#ifndef RAWEVENTTAIL_H
#define RAWEVENTTAIL_H
#include "DAQDataFormats/RawEventTailV0.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawEventTail
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE raweventtail
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {

    namespace CURRENT_FIELDS_SUB_NAMESPACE {
        static const version_t RAWEVENTTAIL_LATEST_VERSION = LAST_CLASS_VERSION;
    }

    class RawEventTail: public PREVIOUS_VERSION_CLASS_NAME{
        public:

            RawEventTail(const version_t version = CURRENT_FIELDS_SUB_NAMESPACE::RAWEVENTTAIL_LATEST_VERSION); //!< Constructor
            RawEventTail(const RawEventTail& copy_in);	    //!< Copyin Constructor
            RawEventTail(const void* buffer, const version_t version = rawdaqdataformat::DAQDATAFORMAT_UNKNOWN_VERSION);  //!< Constructor with data intialization
            ~RawEventTail();                                    //!< Destructor

            IMPLEMENT_MAIN_STANDARD


            IMPLEMENT_GET_MAIN(Marker       , uint32_t)
            IMPLEMENT_GET_MAIN(MarkerLeft   , uint32_t)
            IMPLEMENT_GET_MAIN(MarkerRight  , uint32_t)
            IMPLEMENT_GET_MAIN(Version      , uint32_t)
            IMPLEMENT_GET_AND_SET_MAIN(EventNumberLo, uint32_t)
            IMPLEMENT_GET_AND_SET_MAIN(EventNumberHi, uint32_t)
            IMPLEMENT_GET_AND_SET_MAIN(EventSize    , uint32_t)

            IMPLEMENT_FIGUREOUT_VERSION_STATIC(CURRENT_CLASS)

        protected:

            bool             setFunctionPointers();
            IMPLEMENT_SET_MAIN(MarkerLeft      , uint32_t)
            IMPLEMENT_SET_MAIN(MarkerRight     , uint32_t)
            IMPLEMENT_SET_MAIN(Version         , uint32_t)
            IMPLEMENT_SET_MAIN(Marker          , uint32_t)

    };


} // END NAMESPACE daqdataformats
#endif /* RAWEVENTTAIL_H */
