#ifndef RAWSUMMARYDCMDATAPOINT_H
#define RAWSUMMARYDCMDATAPOINT_H

#include "DAQDataFormats/RawSummaryDCMDataPointV0.h"
#include "DAQDataFormats/Macros.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawSummaryDCMDataPoint
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE summarydcmdatapoint
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {

    namespace CURRENT_FIELDS_SUB_NAMESPACE {
        static const version_t RAWSUMMARYDCMDATAPOINT_LATEST_VERSION = LAST_CLASS_VERSION;
    }

  class RawSummaryDCMDataPoint: public PREVIOUS_VERSION_CLASS_NAME {
    
    public:
        // Constructors
        RawSummaryDCMDataPoint (const version_t version = summarydcmdatapoint::RAWSUMMARYDCMDATAPOINT_LATEST_VERSION); //! The default constructor
        RawSummaryDCMDataPoint (const RawSummaryDCMDataPoint& copy_in);    //! Deep copy constructor
        RawSummaryDCMDataPoint (const void* datapoint_buffer, const version_t version = rawdaqdataformat::DAQDATAFORMAT_UNKNOWN_VERSION ); //! Shallow copy constructor
        /// Destructor
        ~RawSummaryDCMDataPoint();

        IMPLEMENT_MAIN_STANDARD

        IMPLEMENT_GET_MAIN        (Version   , uint32_t)
        IMPLEMENT_GET_AND_SET_MAIN(DCMID, uint32_t)
	IMPLEMENT_GET_AND_SET_MAIN(DataType, uint32_t)
        IMPLEMENT_GET_AND_SET_MAIN(TimeStampLow  , uint32_t)
        IMPLEMENT_GET_AND_SET_MAIN(TimeStampHigh  , uint32_t)
	IMPLEMENT_GET_AND_SET_MAIN(TimeStamp, uint64_t)

	
            IMPLEMENT_FIGUREOUT_VERSION_STATIC(CURRENT_CLASS)

    protected:
        IMPLEMENT_SET_MAIN(Version, uint32_t);
            bool                      setFunctionPointers();
        
  };// end of RawSummaryDCMDataPoint
  
  
} // END NAMESPCE daqdataformats
#endif /* RAWNANOSLICE_H */
