#ifndef RAWSUMMARYDCMDATAV0_H
#define RAWSUMMARYDCMDATAV0_H
#include "DAQDataFormats/RawMicroSlice.h"
#include "DAQDataFormats/RawSummaryDCMDataHeader.h"
#include "DAQDataFormats/RawSummaryDCMDataPoint.h"
#include <list>

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawSummaryDCMData
#define  CURRENT_CLASS_VERSION        0
#define  CURRENT_FIELDS_SUB_NAMESPACE summarydcmdata
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace  VERSION_NAMESPACE {
  class RawSummaryDCMData : public PREVIOUS_VERSION_CLASS_NAME {

        public:
            // Constructors
            RawSummaryDCMData (const version_t); //! The default constructor
            RawSummaryDCMData (const RawSummaryDCMData&);
            /// Destructor
            ~RawSummaryDCMData();

            void     init            ();
            using    PREVIOUS_VERSION_CLASS_NAME::print;
            void     print            (std::ostream& os=std::cout) const;
            uint32_t sizeofdata      () const;
            bool     setBufferSource(const void* pointer);
            
            daqdataformats::RawSummaryDCMDataHeader* getHeader()     const {return _Header;}            //! MicroBlock Header reference
	    daqdataformats::RawSummaryDCMDataPoint* getDataPoint(const uint32_t idx) const;
	    bool addDataPoints(const std::list<std::pair< uint64_t, uint16_t> >& dcmlist, const uint8_t type);

        protected:
            uint32_t getPredefinedSize() const {return summarydcmdatahdr::RAWSUMMARYDCMDATAHEADER_SIZE;}
	   

        protected:
	    INIT_FIRST(getVersion, const, uint32_t, )
	    INIT_CUSTOM_DELEGATE(addDataPoints, bool, const std::list< std::pair<uint64_t, uint16_t> >&, const uint8_t);

            daqdataformats::RawSummaryDCMDataHeader* _Header;          //! MicroBlock Header
  };


}} // END NAMESPCE daqdataformats
#endif /* RawSummaryDCMDataV0_H */
