/**
 * Ndmc header file
 * $Id: Ndmc.h,v 1.6 2011/11/14 04:47:26 kasahara Exp $
 */
#ifndef __NDMC_H_
#define __NDMC_H_

#include <string>

/**
 * Define data types and static utility methods used by the NovaDAQMonitorClient package.
 *
 * @author S. Kasahara
 * @author <a href="mailto:schubert@physics.umn.edu">schubert@physics.umn.edu</a>
 * @date April 28 2010 
 */

/**
 * Namespace name nova::novadaqmonitorclient
 */
#define NDMC_NAMESPACE nova::novadaqmonitorclient

#define NDMC_NAMESPACE_BEGIN \
namespace nova { \
  namespace novadaqmonitorclient { 
#define NDMC_NAMESPACE_END \
  } /* nova  */ \
} /* novadaqmonitorclient */ 

NDMC_NAMESPACE_BEGIN

std::string getConfigFullFilePathName(std::string configFile);

typedef enum MetricType {
    VALUE,
    COUNTER,
    RATE,
    AVERAGE,
    STDEV,
    MINIMUM,
    MAXIMUM,
    HEARTBEAT
} MetricType_t;

NDMC_NAMESPACE_END

#endif // __NDMC_H_

