#ifndef _NOVADAQ_PROCESSUTILS_H
#define _NOVADAQ_PROCESSUTILS_H

#include <boost/thread/mutex.hpp>
#include <vector>

namespace novadaq {

/**
 * Utility functions for working with process information.
 *
 * @author Kurt Biery
 * @version $Revision: 1.2 $ $Date: 2010/11/23 20:11:00 $
 */

class ProcessUtils {

 public:

    static int getDescendantProcessIds(const int& parentPid,
                                       std::vector<int>& descendantPidList);

    static int getDescendantProcessIds(const std::vector<int>& parentPidList,
                                       std::vector<int>& descendantPidList);

    static int getChildProcessIds(const int& parentPid,
                                  std::vector<int>& childPidList);

    static int getChildProcessIds(const std::vector<int>& parentPidList,
                                  std::vector<int>& childPidList);

 protected:

    static boost::mutex _childPidMutex;

};

};  // end of namespace novadaq

#endif
