#include "DAQChannelMap/NDOSDAQChannelMap.h"
#include "DAQChannelMap/DAQChannelMapOLD.h"
#include "DAQChannelMap/BitFields.h"
#include "DAQChannelMap/boundscheck.h"
#include "NovaDAQConventions/DAQConventions.h"
#include <stdio.h>
#include <iostream>
using namespace daqchannelmap;

static DAQChannelMapOLD* gsOldDCMap() 
{
  static DAQChannelMapOLD *oldmap = 0;
  if (oldmap==0) oldmap = DAQChannelMapOLD::getInstance();
  return oldmap;
}

//......................................................................

NDOSDAQChannelMap::NDOSDAQChannelMap() { }

//......................................................................

NDOSDAQChannelMap::~NDOSDAQChannelMap() { }

//......................................................................

dchan NDOSDAQChannelMap::encodeDChan(lchan logicalchan) const
{
  return gsOldDCMap()->encodeDChan(logicalchan);
}

//......................................................................

lchan NDOSDAQChannelMap::encodeLChan(dchan daqchan) const
{
  return gsOldDCMap()->encodeLChan(daqchan);
}

//......................................................................

block_t NDOSDAQChannelMap::computeBlock(lchan logicalchan) const
{
  return gsOldDCMap()->getBlockOffline(logicalchan);
}

//......................................................................

DetView_TYPE NDOSDAQChannelMap::getView(dchan daqchan) const
{
  return gsOldDCMap()->getView(daqchan);
}

//......................................................................

fiber_t NDOSDAQChannelMap::PixelToFiber(pixel_t pixel) const
{
  return pixeltofiber[pixel];
}

//......................................................................

pixel_t NDOSDAQChannelMap::FiberToPixel(fiber_t fiber) const
{
  return fibertopixel[fiber];
}

//......................................................................

plane_t NDOSDAQChannelMap::computePlaneInBlock(lchan logicalchan) const
{
  return gsOldDCMap()->getLocalPlaneInBlockOffline(logicalchan);
}

//......................................................................

unsigned int NDOSDAQChannelMap::computeModule(lchan logicalchan) const
{
  cell_t cell = getCell(logicalchan);
  return cell/32;
}

//......................................................................

fiber_t NDOSDAQChannelMap::computeFiberInModule(dchan daqchan) const
{
  pixel_t pixel = gsOldDCMap()->getPixel(daqchan);
  return PixelToFiber(pixel);
}

//......................................................................

unsigned int NDOSDAQChannelMap::getTotalNumberOfDiblocks() const
{
  return gsOldDCMap()->getTotalNumberOfDiblocks(novadaq::cnv::kNDOS);
}

//......................................................................

unsigned int NDOSDAQChannelMap::getNumberOfDCM(DiBlock_TYPE type) const
{
  return gsOldDCMap()->getNumberOfDCM(novadaq::cnv::kNDOS, type);
}

//......................................................................

DiBlock_TYPE NDOSDAQChannelMap::getDiBlockType(dchan d) const
{
  return gsOldDCMap()->getDiBlockType(d);
}

////////////////////////////////////////////////////////////////////////
