#include "DAQMessages/NSNMessagesDcps_impl.h"
#include "gapi.h"
#include "gapi_loanRegistry.h"
#include "DAQMessages/NSNMessagesSplDcps.h"
#include "ccpp_DataReader_impl.h"
#include "ccpp_DataReaderView_impl.h"


extern c_bool
__nsnmessages_NSNMessage__copyIn(
    c_base base,
    struct nsnmessages::NSNMessage *from,
    struct _nsnmessages_NSNMessage *to);

extern void
__nsnmessages_NSNMessage__copyOut(
    void *_from,
    void *_to);

// DDS nsnmessages::NSNMessage TypeSupportFactory Object Body

 DDS::DataWriter_ptr 
nsnmessages::NSNMessageTypeSupportFactory::create_datawriter (gapi_dataWriter handle)
{
    return new nsnmessages::NSNMessageDataWriter_impl(handle);
}

 DDS::DataReader_ptr 
nsnmessages::NSNMessageTypeSupportFactory::create_datareader (gapi_dataReader handle)
{
    return new nsnmessages::NSNMessageDataReader_impl (handle);
}


 DDS::DataReaderView_ptr 
nsnmessages::NSNMessageTypeSupportFactory::create_view (gapi_dataReaderView handle)
{
    return new nsnmessages::NSNMessageDataReaderView_impl (handle);
}

// DDS nsnmessages::NSNMessage TypeSupport Object Body

 nsnmessages::NSNMessageTypeSupport::NSNMessageTypeSupport(void) :
    TypeSupport_impl(
        __nsnmessages_NSNMessage__name(),
        __nsnmessages_NSNMessage__keys(),
        nsnmessages::NSNMessageTypeSupport::metaDescriptor,
        (gapi_copyIn) __nsnmessages_NSNMessage__copyIn,
        (gapi_copyOut) __nsnmessages_NSNMessage__copyOut,
        (gapi_readerCopy) DDS::ccpp_DataReaderCopy<nsnmessages::NSNMessageSeq, nsnmessages::NSNMessage>,
        new  nsnmessages::NSNMessageTypeSupportFactory())
{
    // Parent constructor takes care of everything.
}

 nsnmessages::NSNMessageTypeSupport::~NSNMessageTypeSupport(void)
{
    // Parent destructor takes care of everything.
}

 DDS::ReturnCode_t
nsnmessages::NSNMessageTypeSupport::register_type(
    DDS::DomainParticipant_ptr domain,
    const char * type_name) THROW_ORB_EXCEPTIONS
{
    return TypeSupport_impl::register_type(domain, type_name);
}

 char *
nsnmessages::NSNMessageTypeSupport::get_type_name() THROW_ORB_EXCEPTIONS
{
    return TypeSupport_impl::get_type_name();
}

// DDS nsnmessages::NSNMessage DataWriter_impl Object Body

 nsnmessages::NSNMessageDataWriter_impl::NSNMessageDataWriter_impl (
    gapi_dataWriter handle
) : DDS::DataWriter_impl(handle)
{
    // Parent constructor takes care of everything.
}

 nsnmessages::NSNMessageDataWriter_impl::~NSNMessageDataWriter_impl(void)
{
    // Parent destructor takes care of everything.
}

 DDS::InstanceHandle_t
nsnmessages::NSNMessageDataWriter_impl::register_instance(
    const nsnmessages::NSNMessage & instance_data) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::register_instance(&instance_data);
}

 DDS::InstanceHandle_t 
nsnmessages::NSNMessageDataWriter_impl::register_instance_w_timestamp(
    const NSNMessage & instance_data,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::register_instance_w_timestamp(&instance_data, source_timestamp);
}

 DDS::ReturnCode_t
nsnmessages::NSNMessageDataWriter_impl::unregister_instance(
    const nsnmessages::NSNMessage & instance_data,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::unregister_instance(&instance_data, handle);
}

 DDS::ReturnCode_t 
nsnmessages::NSNMessageDataWriter_impl::unregister_instance_w_timestamp(
    const NSNMessage & instance_data,
    DDS::InstanceHandle_t handle,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::unregister_instance_w_timestamp(&instance_data, handle, source_timestamp);
}

 DDS::ReturnCode_t
nsnmessages::NSNMessageDataWriter_impl::write(
    const nsnmessages::NSNMessage & instance_data,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::write(&instance_data, handle);
}

 DDS::ReturnCode_t
nsnmessages::NSNMessageDataWriter_impl::write_w_timestamp(
    const NSNMessage & instance_data,
    DDS::InstanceHandle_t handle,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::write_w_timestamp(&instance_data, handle, source_timestamp);
}

 DDS::ReturnCode_t
nsnmessages::NSNMessageDataWriter_impl::dispose(
    const nsnmessages::NSNMessage & instance_data,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::dispose(&instance_data, handle);
}

 DDS::ReturnCode_t 
nsnmessages::NSNMessageDataWriter_impl::dispose_w_timestamp(
    const NSNMessage & instance_data,
    DDS::InstanceHandle_t handle,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::dispose_w_timestamp(&instance_data, handle, source_timestamp);
}

 DDS::ReturnCode_t
nsnmessages::NSNMessageDataWriter_impl::writedispose(
    const nsnmessages::NSNMessage & instance_data,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::writedispose(&instance_data, handle);
}

 DDS::ReturnCode_t
nsnmessages::NSNMessageDataWriter_impl::writedispose_w_timestamp(
    const NSNMessage & instance_data,
    DDS::InstanceHandle_t handle,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::writedispose_w_timestamp(&instance_data, handle, source_timestamp);
}

 DDS::ReturnCode_t 
nsnmessages::NSNMessageDataWriter_impl::get_key_value(
    NSNMessage & key_holder,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::get_key_value(&key_holder, handle);
}

 DDS::InstanceHandle_t 
nsnmessages::NSNMessageDataWriter_impl::lookup_instance(
	const nsnmessages::NSNMessage & instance_data) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::lookup_instance(&instance_data);
}

// DDS nsnmessages::NSNMessage DataReader_impl Object Body

 nsnmessages::NSNMessageDataReader_impl::NSNMessageDataReader_impl (
    gapi_dataReader handle
) : DDS::DataReader_impl(handle)
{
    // Parent constructor takes care of everything.
}

 nsnmessages::NSNMessageDataReader_impl::~NSNMessageDataReader_impl(void)
{
    // Parent destructor takes care of everything.
}


 DDS::ReturnCode_t
nsnmessages::NSNMessageDataReader_impl::read(
    nsnmessages::NSNMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read(&received_data, info_seq, max_samples, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNMessageDataReader_impl::take(
    nsnmessages::NSNMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take(&received_data, info_seq, max_samples, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNMessageDataReader_impl::read_w_condition(
    nsnmessages::NSNMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read_w_condition(&received_data, info_seq, max_samples, a_condition);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNMessageDataReader_impl::take_w_condition(
    nsnmessages::NSNMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take_w_condition(&received_data, info_seq, max_samples, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t 
nsnmessages::NSNMessageDataReader_impl::read_next_sample(
    nsnmessages::NSNMessage & received_data,
    DDS::SampleInfo & sample_info) THROW_ORB_EXCEPTIONS
{
    return DataReader_impl::read_next_sample(&received_data, sample_info);
}


 DDS::ReturnCode_t 
nsnmessages::NSNMessageDataReader_impl::take_next_sample(
    nsnmessages::NSNMessage & received_data,
    DDS::SampleInfo & sample_info) THROW_ORB_EXCEPTIONS
{
    return DataReader_impl::take_next_sample(&received_data, sample_info);
}


 DDS::ReturnCode_t
nsnmessages::NSNMessageDataReader_impl::read_instance(
    nsnmessages::NSNMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNMessageDataReader_impl::take_instance(
    nsnmessages::NSNMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNMessageDataReader_impl::read_next_instance(
    nsnmessages::NSNMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read_next_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNMessageDataReader_impl::take_next_instance(
    nsnmessages::NSNMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take_next_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}


 DDS::ReturnCode_t 
nsnmessages::NSNMessageDataReader_impl::read_next_instance_w_condition(
    nsnmessages::NSNMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read_next_instance_w_condition(&received_data, info_seq, max_samples, a_handle, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t 
nsnmessages::NSNMessageDataReader_impl::take_next_instance_w_condition(
    nsnmessages::NSNMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take_next_instance_w_condition(&received_data, info_seq, max_samples, a_handle, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t
nsnmessages::NSNMessageDataReader_impl::return_loan(
    nsnmessages::NSNMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status = DDS::RETCODE_OK;

    if ( received_data.length() > 0 ) {
        if (received_data.length() == info_seq.length() && 
            received_data.release() == info_seq.release() ) {
            if (!received_data.release()) {
                status = DataReader_impl::return_loan( received_data.get_buffer(),
                                                       info_seq.get_buffer() );

                if ( status == DDS::RETCODE_OK ) {
                    if ( !received_data.release() ) {
                        nsnmessages::NSNMessageSeq::freebuf( received_data.get_buffer(false) );
                        received_data.replace(0, 0, NULL, false);
                        DDS::SampleInfoSeq::freebuf( info_seq.get_buffer(false) );
                        info_seq.replace(0, 0, NULL, false);
                    }
                } else if ( status == DDS::RETCODE_NO_DATA ) {
                    if ( received_data.release() ) {
                        status = DDS::RETCODE_OK;
                    } else {
                        status = DDS::RETCODE_PRECONDITION_NOT_MET;
                    }
                }
            }
        } else {
            status = DDS::RETCODE_PRECONDITION_NOT_MET;
        }
    }
    return status;
}


 DDS::ReturnCode_t 
nsnmessages::NSNMessageDataReader_impl::get_key_value(
    nsnmessages::NSNMessage & key_holder,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataReader_impl::get_key_value(&key_holder, handle);
}

 DDS::InstanceHandle_t 
nsnmessages::NSNMessageDataReader_impl::lookup_instance(
    const nsnmessages::NSNMessage & instance) THROW_ORB_EXCEPTIONS
{
    return DataReader_impl::lookup_instance(&instance);
}

 DDS::ReturnCode_t 
nsnmessages::NSNMessageDataReader_impl::check_preconditions(
    nsnmessages::NSNMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples)
{
    DDS::ReturnCode_t status = DDS::RETCODE_PRECONDITION_NOT_MET;
    
    if ( received_data.length() == info_seq.length() &&
         received_data.maximum() == info_seq.maximum() &&
         received_data.release() == info_seq.release() ) {
        if ( received_data.maximum() == 0 || received_data.release() ) {
            if (received_data.maximum() == 0 ||
				max_samples <= static_cast<CORBA::Long>(received_data.maximum()) ||
				max_samples == DDS::LENGTH_UNLIMITED ) {
                status = DDS::RETCODE_OK;
            }
        }
    }
    return status;
}


// DDS nsnmessages::NSNMessage DataReaderView_impl Object Body

 nsnmessages::NSNMessageDataReaderView_impl::NSNMessageDataReaderView_impl (
    gapi_dataReaderView handle
) : DDS::DataReaderView_impl(handle)
{
    // Parent constructor takes care of everything.
}

 nsnmessages::NSNMessageDataReaderView_impl::~NSNMessageDataReaderView_impl(void)
{
    // Parent destructor takes care of everything.
}


 DDS::ReturnCode_t
nsnmessages::NSNMessageDataReaderView_impl::read(
    nsnmessages::NSNMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = nsnmessages::NSNMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read(&received_data, info_seq, max_samples, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNMessageDataReaderView_impl::take(
    nsnmessages::NSNMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = nsnmessages::NSNMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take(&received_data, info_seq, max_samples, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNMessageDataReaderView_impl::read_w_condition(
    nsnmessages::NSNMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = nsnmessages::NSNMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read_w_condition(&received_data, info_seq, max_samples, a_condition);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNMessageDataReaderView_impl::take_w_condition(
    nsnmessages::NSNMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = nsnmessages::NSNMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take_w_condition(&received_data, info_seq, max_samples, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t 
nsnmessages::NSNMessageDataReaderView_impl::read_next_sample(
    nsnmessages::NSNMessage & received_data,
    DDS::SampleInfo & sample_info) THROW_ORB_EXCEPTIONS
{
    return DataReaderView_impl::read_next_sample(&received_data, sample_info);
}


 DDS::ReturnCode_t 
nsnmessages::NSNMessageDataReaderView_impl::take_next_sample(
    nsnmessages::NSNMessage & received_data,
    DDS::SampleInfo & sample_info) THROW_ORB_EXCEPTIONS
{
    return DataReaderView_impl::take_next_sample(&received_data, sample_info);
}


 DDS::ReturnCode_t
nsnmessages::NSNMessageDataReaderView_impl::read_instance(
    nsnmessages::NSNMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = nsnmessages::NSNMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNMessageDataReaderView_impl::take_instance(
    nsnmessages::NSNMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = nsnmessages::NSNMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNMessageDataReaderView_impl::read_next_instance(
    nsnmessages::NSNMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = nsnmessages::NSNMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read_next_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNMessageDataReaderView_impl::take_next_instance(
    nsnmessages::NSNMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = nsnmessages::NSNMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take_next_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}


 DDS::ReturnCode_t 
nsnmessages::NSNMessageDataReaderView_impl::read_next_instance_w_condition(
    nsnmessages::NSNMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = nsnmessages::NSNMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read_next_instance_w_condition(&received_data, info_seq, max_samples, a_handle, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t 
nsnmessages::NSNMessageDataReaderView_impl::take_next_instance_w_condition(
    nsnmessages::NSNMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = nsnmessages::NSNMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take_next_instance_w_condition(&received_data, info_seq, max_samples, a_handle, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t
nsnmessages::NSNMessageDataReaderView_impl::return_loan(
    nsnmessages::NSNMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status = DDS::RETCODE_OK;

    if ( received_data.length() > 0 ) {
        if (received_data.length() == info_seq.length() && 
            received_data.release() == info_seq.release() ) {
            if (!received_data.release()) {
                status = DataReaderView_impl::return_loan( received_data.get_buffer(),
                                                       info_seq.get_buffer() );

                if ( status == DDS::RETCODE_OK ) {
                    if ( !received_data.release() ) {
                        nsnmessages::NSNMessageSeq::freebuf( received_data.get_buffer(false) );
                        received_data.replace(0, 0, NULL, false);
                        DDS::SampleInfoSeq::freebuf( info_seq.get_buffer(false) );
                        info_seq.replace(0, 0, NULL, false);
                    }
                } else if ( status == DDS::RETCODE_NO_DATA ) {
                    if ( received_data.release() ) {
                        status = DDS::RETCODE_OK;
                    } else {
                        status = DDS::RETCODE_PRECONDITION_NOT_MET;
                    }
                }
            }
        } else {
            status = DDS::RETCODE_PRECONDITION_NOT_MET;
        }
    }
    return status;
}


 DDS::ReturnCode_t 
nsnmessages::NSNMessageDataReaderView_impl::get_key_value(
    nsnmessages::NSNMessage & key_holder,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataReaderView_impl::get_key_value(&key_holder, handle);
}

 DDS::InstanceHandle_t 
nsnmessages::NSNMessageDataReaderView_impl::lookup_instance(
    const nsnmessages::NSNMessage & instance) THROW_ORB_EXCEPTIONS
{
    return DataReaderView_impl::lookup_instance(&instance);
}



extern c_bool
__nsnmessages_NSNPackedMessage__copyIn(
    c_base base,
    struct nsnmessages::NSNPackedMessage *from,
    struct _nsnmessages_NSNPackedMessage *to);

extern void
__nsnmessages_NSNPackedMessage__copyOut(
    void *_from,
    void *_to);

// DDS nsnmessages::NSNPackedMessage TypeSupportFactory Object Body

 DDS::DataWriter_ptr 
nsnmessages::NSNPackedMessageTypeSupportFactory::create_datawriter (gapi_dataWriter handle)
{
    return new nsnmessages::NSNPackedMessageDataWriter_impl(handle);
}

 DDS::DataReader_ptr 
nsnmessages::NSNPackedMessageTypeSupportFactory::create_datareader (gapi_dataReader handle)
{
    return new nsnmessages::NSNPackedMessageDataReader_impl (handle);
}


 DDS::DataReaderView_ptr 
nsnmessages::NSNPackedMessageTypeSupportFactory::create_view (gapi_dataReaderView handle)
{
    return new nsnmessages::NSNPackedMessageDataReaderView_impl (handle);
}

// DDS nsnmessages::NSNPackedMessage TypeSupport Object Body

 nsnmessages::NSNPackedMessageTypeSupport::NSNPackedMessageTypeSupport(void) :
    TypeSupport_impl(
        __nsnmessages_NSNPackedMessage__name(),
        __nsnmessages_NSNPackedMessage__keys(),
        nsnmessages::NSNPackedMessageTypeSupport::metaDescriptor,
        (gapi_copyIn) __nsnmessages_NSNPackedMessage__copyIn,
        (gapi_copyOut) __nsnmessages_NSNPackedMessage__copyOut,
        (gapi_readerCopy) DDS::ccpp_DataReaderCopy<nsnmessages::NSNPackedMessageSeq, nsnmessages::NSNPackedMessage>,
        new  nsnmessages::NSNPackedMessageTypeSupportFactory())
{
    // Parent constructor takes care of everything.
}

 nsnmessages::NSNPackedMessageTypeSupport::~NSNPackedMessageTypeSupport(void)
{
    // Parent destructor takes care of everything.
}

 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageTypeSupport::register_type(
    DDS::DomainParticipant_ptr domain,
    const char * type_name) THROW_ORB_EXCEPTIONS
{
    return TypeSupport_impl::register_type(domain, type_name);
}

 char *
nsnmessages::NSNPackedMessageTypeSupport::get_type_name() THROW_ORB_EXCEPTIONS
{
    return TypeSupport_impl::get_type_name();
}

// DDS nsnmessages::NSNPackedMessage DataWriter_impl Object Body

 nsnmessages::NSNPackedMessageDataWriter_impl::NSNPackedMessageDataWriter_impl (
    gapi_dataWriter handle
) : DDS::DataWriter_impl(handle)
{
    // Parent constructor takes care of everything.
}

 nsnmessages::NSNPackedMessageDataWriter_impl::~NSNPackedMessageDataWriter_impl(void)
{
    // Parent destructor takes care of everything.
}

 DDS::InstanceHandle_t
nsnmessages::NSNPackedMessageDataWriter_impl::register_instance(
    const nsnmessages::NSNPackedMessage & instance_data) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::register_instance(&instance_data);
}

 DDS::InstanceHandle_t 
nsnmessages::NSNPackedMessageDataWriter_impl::register_instance_w_timestamp(
    const NSNPackedMessage & instance_data,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::register_instance_w_timestamp(&instance_data, source_timestamp);
}

 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataWriter_impl::unregister_instance(
    const nsnmessages::NSNPackedMessage & instance_data,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::unregister_instance(&instance_data, handle);
}

 DDS::ReturnCode_t 
nsnmessages::NSNPackedMessageDataWriter_impl::unregister_instance_w_timestamp(
    const NSNPackedMessage & instance_data,
    DDS::InstanceHandle_t handle,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::unregister_instance_w_timestamp(&instance_data, handle, source_timestamp);
}

 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataWriter_impl::write(
    const nsnmessages::NSNPackedMessage & instance_data,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::write(&instance_data, handle);
}

 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataWriter_impl::write_w_timestamp(
    const NSNPackedMessage & instance_data,
    DDS::InstanceHandle_t handle,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::write_w_timestamp(&instance_data, handle, source_timestamp);
}

 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataWriter_impl::dispose(
    const nsnmessages::NSNPackedMessage & instance_data,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::dispose(&instance_data, handle);
}

 DDS::ReturnCode_t 
nsnmessages::NSNPackedMessageDataWriter_impl::dispose_w_timestamp(
    const NSNPackedMessage & instance_data,
    DDS::InstanceHandle_t handle,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::dispose_w_timestamp(&instance_data, handle, source_timestamp);
}

 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataWriter_impl::writedispose(
    const nsnmessages::NSNPackedMessage & instance_data,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::writedispose(&instance_data, handle);
}

 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataWriter_impl::writedispose_w_timestamp(
    const NSNPackedMessage & instance_data,
    DDS::InstanceHandle_t handle,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::writedispose_w_timestamp(&instance_data, handle, source_timestamp);
}

 DDS::ReturnCode_t 
nsnmessages::NSNPackedMessageDataWriter_impl::get_key_value(
    NSNPackedMessage & key_holder,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::get_key_value(&key_holder, handle);
}

 DDS::InstanceHandle_t 
nsnmessages::NSNPackedMessageDataWriter_impl::lookup_instance(
	const nsnmessages::NSNPackedMessage & instance_data) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::lookup_instance(&instance_data);
}

// DDS nsnmessages::NSNPackedMessage DataReader_impl Object Body

 nsnmessages::NSNPackedMessageDataReader_impl::NSNPackedMessageDataReader_impl (
    gapi_dataReader handle
) : DDS::DataReader_impl(handle)
{
    // Parent constructor takes care of everything.
}

 nsnmessages::NSNPackedMessageDataReader_impl::~NSNPackedMessageDataReader_impl(void)
{
    // Parent destructor takes care of everything.
}


 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataReader_impl::read(
    nsnmessages::NSNPackedMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read(&received_data, info_seq, max_samples, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataReader_impl::take(
    nsnmessages::NSNPackedMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take(&received_data, info_seq, max_samples, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataReader_impl::read_w_condition(
    nsnmessages::NSNPackedMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read_w_condition(&received_data, info_seq, max_samples, a_condition);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataReader_impl::take_w_condition(
    nsnmessages::NSNPackedMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take_w_condition(&received_data, info_seq, max_samples, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t 
nsnmessages::NSNPackedMessageDataReader_impl::read_next_sample(
    nsnmessages::NSNPackedMessage & received_data,
    DDS::SampleInfo & sample_info) THROW_ORB_EXCEPTIONS
{
    return DataReader_impl::read_next_sample(&received_data, sample_info);
}


 DDS::ReturnCode_t 
nsnmessages::NSNPackedMessageDataReader_impl::take_next_sample(
    nsnmessages::NSNPackedMessage & received_data,
    DDS::SampleInfo & sample_info) THROW_ORB_EXCEPTIONS
{
    return DataReader_impl::take_next_sample(&received_data, sample_info);
}


 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataReader_impl::read_instance(
    nsnmessages::NSNPackedMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataReader_impl::take_instance(
    nsnmessages::NSNPackedMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataReader_impl::read_next_instance(
    nsnmessages::NSNPackedMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read_next_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataReader_impl::take_next_instance(
    nsnmessages::NSNPackedMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take_next_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}


 DDS::ReturnCode_t 
nsnmessages::NSNPackedMessageDataReader_impl::read_next_instance_w_condition(
    nsnmessages::NSNPackedMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read_next_instance_w_condition(&received_data, info_seq, max_samples, a_handle, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t 
nsnmessages::NSNPackedMessageDataReader_impl::take_next_instance_w_condition(
    nsnmessages::NSNPackedMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take_next_instance_w_condition(&received_data, info_seq, max_samples, a_handle, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataReader_impl::return_loan(
    nsnmessages::NSNPackedMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status = DDS::RETCODE_OK;

    if ( received_data.length() > 0 ) {
        if (received_data.length() == info_seq.length() && 
            received_data.release() == info_seq.release() ) {
            if (!received_data.release()) {
                status = DataReader_impl::return_loan( received_data.get_buffer(),
                                                       info_seq.get_buffer() );

                if ( status == DDS::RETCODE_OK ) {
                    if ( !received_data.release() ) {
                        nsnmessages::NSNPackedMessageSeq::freebuf( received_data.get_buffer(false) );
                        received_data.replace(0, 0, NULL, false);
                        DDS::SampleInfoSeq::freebuf( info_seq.get_buffer(false) );
                        info_seq.replace(0, 0, NULL, false);
                    }
                } else if ( status == DDS::RETCODE_NO_DATA ) {
                    if ( received_data.release() ) {
                        status = DDS::RETCODE_OK;
                    } else {
                        status = DDS::RETCODE_PRECONDITION_NOT_MET;
                    }
                }
            }
        } else {
            status = DDS::RETCODE_PRECONDITION_NOT_MET;
        }
    }
    return status;
}


 DDS::ReturnCode_t 
nsnmessages::NSNPackedMessageDataReader_impl::get_key_value(
    nsnmessages::NSNPackedMessage & key_holder,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataReader_impl::get_key_value(&key_holder, handle);
}

 DDS::InstanceHandle_t 
nsnmessages::NSNPackedMessageDataReader_impl::lookup_instance(
    const nsnmessages::NSNPackedMessage & instance) THROW_ORB_EXCEPTIONS
{
    return DataReader_impl::lookup_instance(&instance);
}

 DDS::ReturnCode_t 
nsnmessages::NSNPackedMessageDataReader_impl::check_preconditions(
    nsnmessages::NSNPackedMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples)
{
    DDS::ReturnCode_t status = DDS::RETCODE_PRECONDITION_NOT_MET;
    
    if ( received_data.length() == info_seq.length() &&
         received_data.maximum() == info_seq.maximum() &&
         received_data.release() == info_seq.release() ) {
        if ( received_data.maximum() == 0 || received_data.release() ) {
            if (received_data.maximum() == 0 ||
				max_samples <= static_cast<CORBA::Long>(received_data.maximum()) ||
				max_samples == DDS::LENGTH_UNLIMITED ) {
                status = DDS::RETCODE_OK;
            }
        }
    }
    return status;
}


// DDS nsnmessages::NSNPackedMessage DataReaderView_impl Object Body

 nsnmessages::NSNPackedMessageDataReaderView_impl::NSNPackedMessageDataReaderView_impl (
    gapi_dataReaderView handle
) : DDS::DataReaderView_impl(handle)
{
    // Parent constructor takes care of everything.
}

 nsnmessages::NSNPackedMessageDataReaderView_impl::~NSNPackedMessageDataReaderView_impl(void)
{
    // Parent destructor takes care of everything.
}


 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataReaderView_impl::read(
    nsnmessages::NSNPackedMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = nsnmessages::NSNPackedMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read(&received_data, info_seq, max_samples, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataReaderView_impl::take(
    nsnmessages::NSNPackedMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = nsnmessages::NSNPackedMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take(&received_data, info_seq, max_samples, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataReaderView_impl::read_w_condition(
    nsnmessages::NSNPackedMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = nsnmessages::NSNPackedMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read_w_condition(&received_data, info_seq, max_samples, a_condition);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataReaderView_impl::take_w_condition(
    nsnmessages::NSNPackedMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = nsnmessages::NSNPackedMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take_w_condition(&received_data, info_seq, max_samples, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t 
nsnmessages::NSNPackedMessageDataReaderView_impl::read_next_sample(
    nsnmessages::NSNPackedMessage & received_data,
    DDS::SampleInfo & sample_info) THROW_ORB_EXCEPTIONS
{
    return DataReaderView_impl::read_next_sample(&received_data, sample_info);
}


 DDS::ReturnCode_t 
nsnmessages::NSNPackedMessageDataReaderView_impl::take_next_sample(
    nsnmessages::NSNPackedMessage & received_data,
    DDS::SampleInfo & sample_info) THROW_ORB_EXCEPTIONS
{
    return DataReaderView_impl::take_next_sample(&received_data, sample_info);
}


 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataReaderView_impl::read_instance(
    nsnmessages::NSNPackedMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = nsnmessages::NSNPackedMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataReaderView_impl::take_instance(
    nsnmessages::NSNPackedMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = nsnmessages::NSNPackedMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataReaderView_impl::read_next_instance(
    nsnmessages::NSNPackedMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = nsnmessages::NSNPackedMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read_next_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataReaderView_impl::take_next_instance(
    nsnmessages::NSNPackedMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = nsnmessages::NSNPackedMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take_next_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}


 DDS::ReturnCode_t 
nsnmessages::NSNPackedMessageDataReaderView_impl::read_next_instance_w_condition(
    nsnmessages::NSNPackedMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = nsnmessages::NSNPackedMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read_next_instance_w_condition(&received_data, info_seq, max_samples, a_handle, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t 
nsnmessages::NSNPackedMessageDataReaderView_impl::take_next_instance_w_condition(
    nsnmessages::NSNPackedMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = nsnmessages::NSNPackedMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take_next_instance_w_condition(&received_data, info_seq, max_samples, a_handle, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t
nsnmessages::NSNPackedMessageDataReaderView_impl::return_loan(
    nsnmessages::NSNPackedMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status = DDS::RETCODE_OK;

    if ( received_data.length() > 0 ) {
        if (received_data.length() == info_seq.length() && 
            received_data.release() == info_seq.release() ) {
            if (!received_data.release()) {
                status = DataReaderView_impl::return_loan( received_data.get_buffer(),
                                                       info_seq.get_buffer() );

                if ( status == DDS::RETCODE_OK ) {
                    if ( !received_data.release() ) {
                        nsnmessages::NSNPackedMessageSeq::freebuf( received_data.get_buffer(false) );
                        received_data.replace(0, 0, NULL, false);
                        DDS::SampleInfoSeq::freebuf( info_seq.get_buffer(false) );
                        info_seq.replace(0, 0, NULL, false);
                    }
                } else if ( status == DDS::RETCODE_NO_DATA ) {
                    if ( received_data.release() ) {
                        status = DDS::RETCODE_OK;
                    } else {
                        status = DDS::RETCODE_PRECONDITION_NOT_MET;
                    }
                }
            }
        } else {
            status = DDS::RETCODE_PRECONDITION_NOT_MET;
        }
    }
    return status;
}


 DDS::ReturnCode_t 
nsnmessages::NSNPackedMessageDataReaderView_impl::get_key_value(
    nsnmessages::NSNPackedMessage & key_holder,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataReaderView_impl::get_key_value(&key_holder, handle);
}

 DDS::InstanceHandle_t 
nsnmessages::NSNPackedMessageDataReaderView_impl::lookup_instance(
    const nsnmessages::NSNPackedMessage & instance) THROW_ORB_EXCEPTIONS
{
    return DataReaderView_impl::lookup_instance(&instance);
}



const char * ::nsnmessages::NSNMessageTypeSupport::metaDescriptor = "<MetaData version=\"1.0.0\"><Module name=\"rmscore\"><Struct name=\"TimeStruct\"><Member name=\"sec\"><ULong/></Member><Member name=\"usec\"><ULong/></Member></Struct><Struct name=\"RmsMessageHeader\"><Member name=\"target\"><String/></Member><Member name=\"channel\"><String/></Member><Member name=\"replyTarget\"><String/></Member><Member name=\"id\"><String/></Member><Member name=\"correlationId\"><String/></Member><Member name=\"sentTime\"><Type name=\"rmscore::TimeStruct\"/></Member><Member name=\"correlationTime\"><Type name=\"rmscore::TimeStruct\"/></Member><Member name=\"priority\"><Long/></Member><Member name=\"partitionNumber\"><Long/></Member><Member name=\"hostName\"><String/></Member><Member name=\"applicationName\"><String/></Member></Struct></Module><Module name=\"nsnmessages\"><Struct name=\"NSNMessage\"><Member name=\"header\"><Type name=\"rmscore::RmsMessageHeader\"/></Member><Member name=\"time\"><LongLong/></Member><Member name=\"hits\"><Long/></Member></Struct></Module></MetaData>";
const char * ::nsnmessages::NSNPackedMessageTypeSupport::metaDescriptor = "<MetaData version=\"1.0.0\"><Module name=\"rmscore\"><Struct name=\"TimeStruct\"><Member name=\"sec\"><ULong/></Member><Member name=\"usec\"><ULong/></Member></Struct><Struct name=\"RmsMessageHeader\"><Member name=\"target\"><String/></Member><Member name=\"channel\"><String/></Member><Member name=\"replyTarget\"><String/></Member><Member name=\"id\"><String/></Member><Member name=\"correlationId\"><String/></Member><Member name=\"sentTime\"><Type name=\"rmscore::TimeStruct\"/></Member><Member name=\"correlationTime\"><Type name=\"rmscore::TimeStruct\"/></Member><Member name=\"priority\"><Long/></Member><Member name=\"partitionNumber\"><Long/></Member><Member name=\"hostName\"><String/></Member><Member name=\"applicationName\"><String/></Member></Struct></Module><Module name=\"nsnmessages\"><Struct name=\"NSNPackedMessage\"><Member name=\"header\"><Type name=\"rmscore::RmsMessageHeader\"/></Member><Member name=\"time\"><Array size=\"10\"><LongLong/></Array></Member><Member name=\"hits\"><Array size=\"10\"><Long/></Array></Member></Struct></Module></MetaData>";
