#include "NovaDatabase/Table.h"
#include "NovaDatabase/Util.h"
#include "DatabaseUtils/RunHistory/RunHistory.h"

using namespace nova::database;
using namespace dbutils;
using namespace std;

int main(int argc, char **argv)
{
  if (argc < 2) return 1;

  int irun = 1;
  while (irun < argc) {
    int run = atoi(argv[irun]);
    ++irun;

    std::string detStr = "NDOS";

    RunHistory* rh = new RunHistory(run,detStr);
    
    if (!rh) return 2;
    
    int nDCMs = rh->NDCMs();
    for (int i=0; i<nDCMs; ++i) {
      const RunHistory::DCM dcm = rh->GetDCM(i);
      std::map<int,RunHistory::FEB> febList = dcm.feb;
      std::map<int,RunHistory::FEB>::iterator itr    = febList.begin();
      std::map<int,RunHistory::FEB>::iterator itrEnd = febList.end();
      int ic = 0;
      int tot = 0;
      for (; itr != itrEnd; ++itr) {
	RunHistory::FEB feb = itr->second;
	if (feb.isEnabled) ic += feb.nActivePix;
	tot += 32;
      }
      cout << "UPDATE daq_resources_by_run set (nactivechan,totchan)=("
	   << ic << "," << tot << ") where run=" << run << " and appname='"
	   << dcm.appname << "' and detector='NDOS';" << endl;
      
    }
  }

}


