#include "NovaDatabase/Table.h"
#include "NovaDatabase/Util.h"
#include "DatabaseUtils/RunHistory/RunHistory.h"

using namespace nova::database;
using namespace dbutils;
using namespace std;

int main(int argc, char **argv)
{
  if (argc != 2) return 1;

  int run = atoi(argv[1]);
  std::string detStr = "NDOS";

  RunHistory rh(run,detStr);

  cout << "Run: " << run << endl;
  cout << "Number of subruns: " << rh.NSubruns() << endl;
  cout << "tStart = " << rh.TStartAsString() << endl;
  string tstop = rh.TStopAsString();
  if (tstop == "")
    tstop = "Unknown (the run either crashed or is in progress)";
  cout << "tStop = " << tstop << endl;
  cout << "Number of Active Channels: " << rh.NActiveChannels();
  cout << " / " << rh.NTotalChannels() << "\n";
  cout << "Number of Masked Off FEBs: " << rh.NMaskedOffFEBs();
  cout << " / " << rh.NTotalFEBs() << "\n";
  cout << "Masked-off FEBs: \n";

  int nDCMs = rh.NDCMs();
  for (int i=0; i<nDCMs; ++i) {
    const RunHistory::DCM dcm = rh.GetDCM(i);
    cout << "\t" << dcm.appname << ": ";
    std::map<int,RunHistory::FEB> febList = dcm.feb;
    std::map<int,RunHistory::FEB>::iterator itr    = febList.begin();
    std::map<int,RunHistory::FEB>::iterator itrEnd = febList.end();
    int ic = 0;
    for (; itr != itrEnd; ++itr) {
      RunHistory::FEB feb = itr->second;
      if (! feb.isEnabled) {
	if (ic == 0)
	  cout << feb.loc;
	else
	  cout << "," << feb.loc;
	++ic;
      }
    }
    cout << endl;
  }
  
}


