// Copyright (c) 2005-2014 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/pre.hxx>

#include <rms/RmsMessageSchema.h>

namespace gov
{
  namespace fnal
  {
    namespace cd
    {
      namespace rms
      {
        namespace xsd
        {
          template <class X>
          struct copyTraits
          {
            static void copyNeededFields(X const& source, X& target) {}
            template <class Y>
            static void copyNeededFields(X const& source, Y& target) {}
          };

          template <>
          struct copyTraits<destination>
          {
            static void copyNeededFields(destination const& source, destination& target) {
              target.copyNeededFields(source);
            }
            template <class Y>
            static void copyNeededFields(destination const& source, Y& target) {
              target->copyNeededFields(source);
            }
          };

          template <>
          struct copyTraits<messageBody>
          {
            static void copyNeededFields(messageBody const& source, messageBody& target) {
              target.copyNeededFields(source);
            }
            template <class Y>
            static void copyNeededFields(messageBody const& source, Y& target) {
              target->copyNeededFields(source);
            }
          };

          template <>
          struct copyTraits<messageSource>
          {
            static void copyNeededFields(messageSource const& source, messageSource& target) {
              target.copyNeededFields(source);
            }
            template <class Y>
            static void copyNeededFields(messageSource const& source, Y& target) {
              target->copyNeededFields(source);
            }
          };

          template <>
          struct copyTraits<property>
          {
            static void copyNeededFields(property const& source, property& target) {
              target.copyNeededFields(source);
            }
            template <class Y>
            static void copyNeededFields(property const& source, Y& target) {
              target->copyNeededFields(source);
            }
          };

          template <>
          struct copyTraits<rmsMessage>
          {
            static void copyNeededFields(rmsMessage const& source, rmsMessage& target) {
              target.copyNeededFields(source);
            }
            template <class Y>
            static void copyNeededFields(rmsMessage const& source, Y& target) {
              target->copyNeededFields(source);
            }
          };

          // messageBody
          // 

          const messageBody::content_type& messageBody::
          content () const
          {
            return this->content_.get ();
          }

          messageBody::content_type& messageBody::
          content ()
          {
            return this->content_.get ();
          }

          const messageBody::content_type& messageBody::
          getContent () const
          {
            return this->content_.get ();
          }

          bool messageBody::
          hasContent () const
          {
            return this->content_.present ();
          }

          void messageBody::
          content (const content_type& x)
          {
            this->content_.set (x);
          }

          void messageBody::
          setContent (const content_type& x)
          {
            this->content_.set (x);
          }

          void messageBody::
          content (::std::auto_ptr< content_type > x)
          {
            this->content_.set (x);
          }

          const messageBody::className_type& messageBody::
          className () const
          {
            return this->className_.get ();
          }

          messageBody::className_type& messageBody::
          className ()
          {
            return this->className_.get ();
          }

          const messageBody::className_type& messageBody::
          getClassName () const
          {
            return this->className_.get ();
          }

          bool messageBody::
          hasClassName () const
          {
            return this->className_.present ();
          }

          void messageBody::
          className (const className_type& x)
          {
            this->className_.set (x);
          }

          void messageBody::
          setClassName (const className_type& x)
          {
            this->className_.set (x);
          }

          void messageBody::
          className (::std::auto_ptr< className_type > x)
          {
            this->className_.set (x);
          }


          // messageSource
          // 

          const messageSource::hostName_type& messageSource::
          hostName () const
          {
            return this->hostName_.get ();
          }

          messageSource::hostName_type& messageSource::
          hostName ()
          {
            return this->hostName_.get ();
          }

          const messageSource::hostName_type& messageSource::
          getHostName () const
          {
            return this->hostName_.get ();
          }

          bool messageSource::
          hasHostName () const
          {
            return this->hostName_.present ();
          }

          void messageSource::
          hostName (const hostName_type& x)
          {
            this->hostName_.set (x);
          }

          void messageSource::
          setHostName (const hostName_type& x)
          {
            this->hostName_.set (x);
          }

          void messageSource::
          hostName (::std::auto_ptr< hostName_type > x)
          {
            this->hostName_.set (x);
          }

          const messageSource::applicationName_type& messageSource::
          applicationName () const
          {
            return this->applicationName_.get ();
          }

          messageSource::applicationName_type& messageSource::
          applicationName ()
          {
            return this->applicationName_.get ();
          }

          const messageSource::applicationName_type& messageSource::
          getApplicationName () const
          {
            return this->applicationName_.get ();
          }

          bool messageSource::
          hasApplicationName () const
          {
            return this->applicationName_.present ();
          }

          void messageSource::
          applicationName (const applicationName_type& x)
          {
            this->applicationName_.set (x);
          }

          void messageSource::
          setApplicationName (const applicationName_type& x)
          {
            this->applicationName_.set (x);
          }

          void messageSource::
          applicationName (::std::auto_ptr< applicationName_type > x)
          {
            this->applicationName_.set (x);
          }


          // destination
          // 

          const destination::property_sequence& destination::
          property () const
          {
            return this->property_;
          }

          destination::property_sequence& destination::
          property ()
          {
            return this->property_;
          }

          ::xml_schema::integer destination::
          getPropertyCount () const
          {
            return this->property_.size ();
          }

          const destination::property_type& destination::
          getProperty (int index) const
          {
            return this->property_[index];
          }

          destination::property_type& destination::
          getPropertyReference (int index)
          {
            return this->property_[index];
          }

          bool destination::
          hasProperty () const
          {
            return ! (this->property_.empty ());
          }

          void destination::
          removeAllProperty ()
          {
            this->property_.clear ();
          }

          void destination::
          property (const property_sequence& s)
          {
            this->property_ = s;
          }

          void destination::
          addProperty (const destination::property_type& newProperty)
          {
            this->property_.push_back (newProperty);
          }


          // property
          // 

          const property::value_type& property::
          value () const
          {
            return this->value_.get ();
          }

          property::value_type& property::
          value ()
          {
            return this->value_.get ();
          }

          const property::value_type& property::
          getValue () const
          {
            return this->value_.get ();
          }

          bool property::
          hasValue () const
          {
            return this->value_.present ();
          }

          void property::
          value (const value_type& x)
          {
            this->value_.set (x);
          }

          void property::
          setValue (const value_type& x)
          {
            this->value_.set (x);
          }

          void property::
          value (::std::auto_ptr< value_type > x)
          {
            this->value_.set (x);
          }

          const property::name_type& property::
          name () const
          {
            return this->name_.get ();
          }

          property::name_type& property::
          name ()
          {
            return this->name_.get ();
          }

          const property::name_type& property::
          getName () const
          {
            return this->name_.get ();
          }

          bool property::
          hasName () const
          {
            return this->name_.present ();
          }

          void property::
          name (const name_type& x)
          {
            this->name_.set (x);
          }

          void property::
          setName (const name_type& x)
          {
            this->name_.set (x);
          }

          void property::
          name (::std::auto_ptr< name_type > x)
          {
            this->name_.set (x);
          }


          // rmsMessage
          // 

          const rmsMessage::destination_type& rmsMessage::
          destination () const
          {
            return this->destination_.get ();
          }

          rmsMessage::destination_type& rmsMessage::
          destination ()
          {
            return this->destination_.get ();
          }

          const rmsMessage::destination_type& rmsMessage::
          getDestination () const
          {
            return this->destination_.get ();
          }

          bool rmsMessage::
          hasDestination () const
          {
            return this->destination_.present ();
          }

          void rmsMessage::
          destination (const destination_type& x)
          {
            this->destination_.set (x);
          }

          void rmsMessage::
          setDestination (const destination_type& x)
          {
            this->destination_.set (x);
          }

          void rmsMessage::
          destination (::std::auto_ptr< destination_type > x)
          {
            this->destination_.set (x);
          }

          const rmsMessage::replyDestination_optional& rmsMessage::
          replyDestination () const
          {
            return this->replyDestination_;
          }

          rmsMessage::replyDestination_optional& rmsMessage::
          replyDestination ()
          {
            return this->replyDestination_;
          }

          const rmsMessage::replyDestination_type& rmsMessage::
          getReplyDestination () const
          {
            return this->replyDestination_.get ();
          }

          bool rmsMessage::
          hasReplyDestination () const
          {
            return this->replyDestination_.present ();
          }

          void rmsMessage::
          replyDestination (const replyDestination_type& x)
          {
            this->replyDestination_.set (x);
          }

          void rmsMessage::
          setReplyDestination (const replyDestination_type& x)
          {
            this->replyDestination_.set (x);
          }

          void rmsMessage::
          replyDestination (const replyDestination_optional& x)
          {
            this->replyDestination_ = x;
          }

          void rmsMessage::
          replyDestination (::std::auto_ptr< replyDestination_type > x)
          {
            this->replyDestination_.set (x);
          }

          const rmsMessage::source_optional& rmsMessage::
          source () const
          {
            return this->source_;
          }

          rmsMessage::source_optional& rmsMessage::
          source ()
          {
            return this->source_;
          }

          const rmsMessage::source_type& rmsMessage::
          getSource () const
          {
            return this->source_.get ();
          }

          bool rmsMessage::
          hasSource () const
          {
            return this->source_.present ();
          }

          void rmsMessage::
          source (const source_type& x)
          {
            this->source_.set (x);
          }

          void rmsMessage::
          setSource (const source_type& x)
          {
            this->source_.set (x);
          }

          void rmsMessage::
          source (const source_optional& x)
          {
            this->source_ = x;
          }

          void rmsMessage::
          source (::std::auto_ptr< source_type > x)
          {
            this->source_.set (x);
          }

          const rmsMessage::body_optional& rmsMessage::
          body () const
          {
            return this->body_;
          }

          rmsMessage::body_optional& rmsMessage::
          body ()
          {
            return this->body_;
          }

          const rmsMessage::body_type& rmsMessage::
          getBody () const
          {
            return this->body_.get ();
          }

          bool rmsMessage::
          hasBody () const
          {
            return this->body_.present ();
          }

          void rmsMessage::
          body (const body_type& x)
          {
            this->body_.set (x);
          }

          void rmsMessage::
          setBody (const body_type& x)
          {
            this->body_.set (x);
          }

          void rmsMessage::
          body (const body_optional& x)
          {
            this->body_ = x;
          }

          void rmsMessage::
          body (::std::auto_ptr< body_type > x)
          {
            this->body_.set (x);
          }

          const rmsMessage::id_type& rmsMessage::
          id () const
          {
            return this->id_.get ();
          }

          rmsMessage::id_type& rmsMessage::
          id ()
          {
            return this->id_.get ();
          }

          const rmsMessage::id_type& rmsMessage::
          getId () const
          {
            return this->id_.get ();
          }

          bool rmsMessage::
          hasId () const
          {
            return this->id_.present ();
          }

          void rmsMessage::
          id (const id_type& x)
          {
            this->id_.set (x);
          }

          void rmsMessage::
          setId (const id_type& x)
          {
            this->id_.set (x);
          }

          void rmsMessage::
          id (::std::auto_ptr< id_type > x)
          {
            this->id_.set (x);
          }

          const rmsMessage::correlationId_optional& rmsMessage::
          correlationId () const
          {
            return this->correlationId_;
          }

          rmsMessage::correlationId_optional& rmsMessage::
          correlationId ()
          {
            return this->correlationId_;
          }

          const rmsMessage::correlationId_type& rmsMessage::
          getCorrelationId () const
          {
            return this->correlationId_.get ();
          }

          bool rmsMessage::
          hasCorrelationId () const
          {
            return this->correlationId_.present ();
          }

          void rmsMessage::
          correlationId (const correlationId_type& x)
          {
            this->correlationId_.set (x);
          }

          void rmsMessage::
          setCorrelationId (const correlationId_type& x)
          {
            this->correlationId_.set (x);
          }

          void rmsMessage::
          correlationId (const correlationId_optional& x)
          {
            this->correlationId_ = x;
          }

          void rmsMessage::
          correlationId (::std::auto_ptr< correlationId_type > x)
          {
            this->correlationId_.set (x);
          }

          const rmsMessage::sentTime_type& rmsMessage::
          sentTime () const
          {
            return this->sentTime_.get ();
          }

          rmsMessage::sentTime_type& rmsMessage::
          sentTime ()
          {
            return this->sentTime_.get ();
          }

          const rmsMessage::sentTime_type& rmsMessage::
          getSentTime () const
          {
            return this->sentTime_.get ();
          }

          bool rmsMessage::
          hasSentTime () const
          {
            return this->sentTime_.present ();
          }

          void rmsMessage::
          sentTime (const sentTime_type& x)
          {
            this->sentTime_.set (x);
          }

          void rmsMessage::
          setSentTime (const sentTime_type& x)
          {
            this->sentTime_.set (x);
          }

          void rmsMessage::
          sentTime (::std::auto_ptr< sentTime_type > x)
          {
            this->sentTime_.set (x);
          }

          const rmsMessage::timeToLive_type& rmsMessage::
          timeToLive () const
          {
            return this->timeToLive_.get ();
          }

          rmsMessage::timeToLive_type& rmsMessage::
          timeToLive ()
          {
            return this->timeToLive_.get ();
          }

          const rmsMessage::timeToLive_type& rmsMessage::
          getTimeToLive () const
          {
            return this->timeToLive_.get ();
          }

          bool rmsMessage::
          hasTimeToLive () const
          {
            return this->timeToLive_.present ();
          }

          void rmsMessage::
          timeToLive (const timeToLive_type& x)
          {
            this->timeToLive_.set (x);
          }

          void rmsMessage::
          setTimeToLive (const timeToLive_type& x)
          {
            this->timeToLive_.set (x);
          }

          const rmsMessage::correlationTime_optional& rmsMessage::
          correlationTime () const
          {
            return this->correlationTime_;
          }

          rmsMessage::correlationTime_optional& rmsMessage::
          correlationTime ()
          {
            return this->correlationTime_;
          }

          const rmsMessage::correlationTime_type& rmsMessage::
          getCorrelationTime () const
          {
            return this->correlationTime_.get ();
          }

          bool rmsMessage::
          hasCorrelationTime () const
          {
            return this->correlationTime_.present ();
          }

          void rmsMessage::
          correlationTime (const correlationTime_type& x)
          {
            this->correlationTime_.set (x);
          }

          void rmsMessage::
          setCorrelationTime (const correlationTime_type& x)
          {
            this->correlationTime_.set (x);
          }

          void rmsMessage::
          correlationTime (const correlationTime_optional& x)
          {
            this->correlationTime_ = x;
          }

          void rmsMessage::
          correlationTime (::std::auto_ptr< correlationTime_type > x)
          {
            this->correlationTime_.set (x);
          }

          const rmsMessage::priority_optional& rmsMessage::
          priority () const
          {
            return this->priority_;
          }

          rmsMessage::priority_optional& rmsMessage::
          priority ()
          {
            return this->priority_;
          }

          const rmsMessage::priority_type& rmsMessage::
          getPriority () const
          {
            return this->priority_.get ();
          }

          bool rmsMessage::
          hasPriority () const
          {
            return this->priority_.present ();
          }

          void rmsMessage::
          priority (const priority_type& x)
          {
            this->priority_.set (x);
          }

          void rmsMessage::
          setPriority (const priority_type& x)
          {
            this->priority_.set (x);
          }

          void rmsMessage::
          priority (const priority_optional& x)
          {
            this->priority_ = x;
          }
        }
      }
    }
  }
}

#include <xsd/cxx/xml/dom/parsing-source.hxx>
#include <xsd/cxx/xml/sax/std-input-source.hxx>
#include <xsd/cxx/tree/error-handler.hxx>

namespace gov
{
  namespace fnal
  {
    namespace cd
    {
      namespace rms
      {
        namespace xsd
        {
          // messageBody
          //

          messageBody::
          messageBody ()
          : ::xml_schema::type (),
            content_ (this),
            className_ (this)
          {
          }

          messageBody::
          messageBody (const content_type& content,
                       const className_type& className)
          : ::xml_schema::type (),
            content_ (content, this),
            className_ (className, this)
          {
          }

          messageBody::
          messageBody (const messageBody& x,
                       ::xml_schema::flags f,
                       ::xml_schema::container* c)
          : ::xml_schema::type (x, f, c),
            content_ (x.content_, f, this),
            className_ (x.className_, f, this)
          {
          }

          messageBody::
          messageBody (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f,
                       ::xml_schema::container* c)
          : ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
            content_ (this),
            className_ (this)
          {
            if ((f & ::xml_schema::flags::base) == 0)
            {
              ::xsd::cxx::xml::dom::parser< char > p (e, true, false, true);
              this->parse (p, f);
            }
          }

          void messageBody::
          parse (::xsd::cxx::xml::dom::parser< char >& p,
                 ::xml_schema::flags f)
          {
            for (; p.more_content (); p.next_content (false))
            {
              const ::xercesc::DOMElement& i (p.cur_element ());
              const ::xsd::cxx::xml::qualified_name< char > n (
                ::xsd::cxx::xml::dom::name< char > (i));

              // content
              //
              if (n.name () == "content" && n.namespace_ ().empty ())
              {
                ::std::auto_ptr< content_type > r (
                  content_traits::create (i, f, this));

                if (!content_.present ())
                {
                  this->content_.set (r);
                  continue;
                }
              }

              break;
            }

            if (!content_.present ())
            {
              if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
              {
                std::cerr << "ERROR: expected element (messageBody::content) not found!" << std::endl;
                throw ::xsd::cxx::tree::expected_element< char > (
                  "content",
                  "");
              }
            }

            while (p.more_attributes ())
            {
              const ::xercesc::DOMAttr& i (p.next_attribute ());
              const ::xsd::cxx::xml::qualified_name< char > n (
                ::xsd::cxx::xml::dom::name< char > (i));

              if (n.name () == "className" && n.namespace_ ().empty ())
              {
                this->className_.set (className_traits::create (i, f, this));
                continue;
              }
            }

            if (!className_.present ())
            {
              if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
              {
                std::cerr << "ERROR: expected attribute (messageBody::className) not found!" << std::endl;
                throw ::xsd::cxx::tree::expected_attribute< char > (
                  "className",
                  "");
              }
            }
          }

          messageBody* messageBody::
          _clone (::xml_schema::flags f,
                  ::xml_schema::container* c) const
          {
            return new class messageBody (*this, f, c);
          }

          messageBody& messageBody::
          operator= (const messageBody& x)
          {
            if (this != &x)
            {
              static_cast< ::xml_schema::type& > (*this) = x;
              this->content_ = x.content_;
              this->className_ = x.className_;
            }

            return *this;
          }

          messageBody::
          ~messageBody ()
          {
          }

          void messageBody::
          copyNeededFields (const messageBody& x)
          {
            if (x.hasClassName()) {
              if (! this->hasClassName()) {
                this->setClassName(x.getClassName());
              }
              else {
                copyTraits<className_type>::copyNeededFields(x.getClassName(), this->className());
              }
            }
            if (x.hasContent()) {
              if (! this->hasContent()) {
                this->setContent(x.getContent());
              }
              else {
                copyTraits<content_type>::copyNeededFields(x.getContent(), this->content());
              }
            }
          }

          // messageSource
          //

          messageSource::
          messageSource ()
          : ::xml_schema::type (),
            hostName_ (this),
            applicationName_ (this)
          {
          }

          messageSource::
          messageSource (const hostName_type& hostName,
                         const applicationName_type& applicationName)
          : ::xml_schema::type (),
            hostName_ (hostName, this),
            applicationName_ (applicationName, this)
          {
          }

          messageSource::
          messageSource (const messageSource& x,
                         ::xml_schema::flags f,
                         ::xml_schema::container* c)
          : ::xml_schema::type (x, f, c),
            hostName_ (x.hostName_, f, this),
            applicationName_ (x.applicationName_, f, this)
          {
          }

          messageSource::
          messageSource (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f,
                         ::xml_schema::container* c)
          : ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
            hostName_ (this),
            applicationName_ (this)
          {
            if ((f & ::xml_schema::flags::base) == 0)
            {
              ::xsd::cxx::xml::dom::parser< char > p (e, false, false, true);
              this->parse (p, f);
            }
          }

          void messageSource::
          parse (::xsd::cxx::xml::dom::parser< char >& p,
                 ::xml_schema::flags f)
          {
            while (p.more_attributes ())
            {
              const ::xercesc::DOMAttr& i (p.next_attribute ());
              const ::xsd::cxx::xml::qualified_name< char > n (
                ::xsd::cxx::xml::dom::name< char > (i));

              if (n.name () == "hostName" && n.namespace_ ().empty ())
              {
                this->hostName_.set (hostName_traits::create (i, f, this));
                continue;
              }

              if (n.name () == "applicationName" && n.namespace_ ().empty ())
              {
                this->applicationName_.set (applicationName_traits::create (i, f, this));
                continue;
              }
            }

            if (!hostName_.present ())
            {
              if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
              {
                std::cerr << "ERROR: expected attribute (messageSource::hostName) not found!" << std::endl;
                throw ::xsd::cxx::tree::expected_attribute< char > (
                  "hostName",
                  "");
              }
            }

            if (!applicationName_.present ())
            {
              if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
              {
                std::cerr << "ERROR: expected attribute (messageSource::applicationName) not found!" << std::endl;
                throw ::xsd::cxx::tree::expected_attribute< char > (
                  "applicationName",
                  "");
              }
            }
          }

          messageSource* messageSource::
          _clone (::xml_schema::flags f,
                  ::xml_schema::container* c) const
          {
            return new class messageSource (*this, f, c);
          }

          messageSource& messageSource::
          operator= (const messageSource& x)
          {
            if (this != &x)
            {
              static_cast< ::xml_schema::type& > (*this) = x;
              this->hostName_ = x.hostName_;
              this->applicationName_ = x.applicationName_;
            }

            return *this;
          }

          messageSource::
          ~messageSource ()
          {
          }

          void messageSource::
          copyNeededFields (const messageSource& x)
          {
            if (x.hasApplicationName()) {
              if (! this->hasApplicationName()) {
                this->setApplicationName(x.getApplicationName());
              }
              else {
                copyTraits<applicationName_type>::copyNeededFields(x.getApplicationName(), this->applicationName());
              }
            }
            if (x.hasHostName()) {
              if (! this->hasHostName()) {
                this->setHostName(x.getHostName());
              }
              else {
                copyTraits<hostName_type>::copyNeededFields(x.getHostName(), this->hostName());
              }
            }
          }

          // destination
          //

          destination::
          destination ()
          : ::xml_schema::type (),
            property_ (this)
          {
          }

          destination::
          destination (const destination& x,
                       ::xml_schema::flags f,
                       ::xml_schema::container* c)
          : ::xml_schema::type (x, f, c),
            property_ (x.property_, f, this)
          {
          }

          destination::
          destination (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f,
                       ::xml_schema::container* c)
          : ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
            property_ (this)
          {
            if ((f & ::xml_schema::flags::base) == 0)
            {
              ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
              this->parse (p, f);
            }
          }

          void destination::
          parse (::xsd::cxx::xml::dom::parser< char >& p,
                 ::xml_schema::flags f)
          {
            for (; p.more_content (); p.next_content (false))
            {
              const ::xercesc::DOMElement& i (p.cur_element ());
              const ::xsd::cxx::xml::qualified_name< char > n (
                ::xsd::cxx::xml::dom::name< char > (i));

              // property
              //
              if (n.name () == "property" && n.namespace_ ().empty ())
              {
                ::std::auto_ptr< property_type > r (
                  property_traits::create (i, f, this));

                this->property_.push_back (r);
                continue;
              }

              break;
            }
          }

          destination* destination::
          _clone (::xml_schema::flags f,
                  ::xml_schema::container* c) const
          {
            return new class destination (*this, f, c);
          }

          destination& destination::
          operator= (const destination& x)
          {
            if (this != &x)
            {
              static_cast< ::xml_schema::type& > (*this) = x;
              this->property_ = x.property_;
            }

            return *this;
          }

          destination::
          ~destination ()
          {
          }

          void destination::
          copyNeededFields (const destination& x)
          {
            if (x.hasProperty() && x.getPropertyCount() > 0) {
              if (! this->hasProperty() || this->getPropertyCount() == 0) {
                for (::xml_schema::integer idx = 0; idx < x.getPropertyCount(); ++idx) {
                    this->addProperty(x.getProperty(idx));
                }
              }
              //else {
              //  copyTraits<property_type>::copyNeededFields(x.getProperty(), this->property());
              //}
            }
          }

          // property
          //

          property::
          property ()
          : ::xml_schema::type (),
            value_ (this),
            name_ (this)
          {
          }

          property::
          property (const value_type& value,
                    const name_type& name)
          : ::xml_schema::type (),
            value_ (value, this),
            name_ (name, this)
          {
          }

          property::
          property (const property& x,
                    ::xml_schema::flags f,
                    ::xml_schema::container* c)
          : ::xml_schema::type (x, f, c),
            value_ (x.value_, f, this),
            name_ (x.name_, f, this)
          {
          }

          property::
          property (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f,
                    ::xml_schema::container* c)
          : ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
            value_ (this),
            name_ (this)
          {
            if ((f & ::xml_schema::flags::base) == 0)
            {
              ::xsd::cxx::xml::dom::parser< char > p (e, true, false, true);
              this->parse (p, f);
            }
          }

          void property::
          parse (::xsd::cxx::xml::dom::parser< char >& p,
                 ::xml_schema::flags f)
          {
            for (; p.more_content (); p.next_content (false))
            {
              const ::xercesc::DOMElement& i (p.cur_element ());
              const ::xsd::cxx::xml::qualified_name< char > n (
                ::xsd::cxx::xml::dom::name< char > (i));

              // value
              //
              if (n.name () == "value" && n.namespace_ ().empty ())
              {
                ::std::auto_ptr< value_type > r (
                  value_traits::create (i, f, this));

                if (!value_.present ())
                {
                  this->value_.set (r);
                  continue;
                }
              }

              break;
            }

            if (!value_.present ())
            {
              if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
              {
                std::cerr << "ERROR: expected element (property::value) not found!" << std::endl;
                throw ::xsd::cxx::tree::expected_element< char > (
                  "value",
                  "");
              }
            }

            while (p.more_attributes ())
            {
              const ::xercesc::DOMAttr& i (p.next_attribute ());
              const ::xsd::cxx::xml::qualified_name< char > n (
                ::xsd::cxx::xml::dom::name< char > (i));

              if (n.name () == "name" && n.namespace_ ().empty ())
              {
                this->name_.set (name_traits::create (i, f, this));
                continue;
              }
            }

            if (!name_.present ())
            {
              if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
              {
                std::cerr << "ERROR: expected attribute (property::name) not found!" << std::endl;
                throw ::xsd::cxx::tree::expected_attribute< char > (
                  "name",
                  "");
              }
            }
          }

          property* property::
          _clone (::xml_schema::flags f,
                  ::xml_schema::container* c) const
          {
            return new class property (*this, f, c);
          }

          property& property::
          operator= (const property& x)
          {
            if (this != &x)
            {
              static_cast< ::xml_schema::type& > (*this) = x;
              this->value_ = x.value_;
              this->name_ = x.name_;
            }

            return *this;
          }

          property::
          ~property ()
          {
          }

          void property::
          copyNeededFields (const property& x)
          {
            if (x.hasName()) {
              if (! this->hasName()) {
                this->setName(x.getName());
              }
              else {
                copyTraits<name_type>::copyNeededFields(x.getName(), this->name());
              }
            }
            if (x.hasValue()) {
              if (! this->hasValue()) {
                this->setValue(x.getValue());
              }
              else {
                copyTraits<value_type>::copyNeededFields(x.getValue(), this->value());
              }
            }
          }

          // rmsMessage
          //

          rmsMessage::
          rmsMessage ()
          : ::xml_schema::type (),
            destination_ (this),
            replyDestination_ (this),
            source_ (this),
            body_ (this),
            id_ (this),
            correlationId_ (this),
            sentTime_ (this),
            timeToLive_ (this),
            correlationTime_ (this),
            priority_ (this)
          {
          }

          rmsMessage::
          rmsMessage (const destination_type& destination,
                      const id_type& id,
                      const sentTime_type& sentTime,
                      const timeToLive_type& timeToLive)
          : ::xml_schema::type (),
            destination_ (destination, this),
            replyDestination_ (this),
            source_ (this),
            body_ (this),
            id_ (id, this),
            correlationId_ (this),
            sentTime_ (sentTime, this),
            timeToLive_ (timeToLive, this),
            correlationTime_ (this),
            priority_ (this)
          {
          }

          rmsMessage::
          rmsMessage (::std::auto_ptr< destination_type > destination,
                      const id_type& id,
                      const sentTime_type& sentTime,
                      const timeToLive_type& timeToLive)
          : ::xml_schema::type (),
            destination_ (destination, this),
            replyDestination_ (this),
            source_ (this),
            body_ (this),
            id_ (id, this),
            correlationId_ (this),
            sentTime_ (sentTime, this),
            timeToLive_ (timeToLive, this),
            correlationTime_ (this),
            priority_ (this)
          {
          }

          rmsMessage::
          rmsMessage (const rmsMessage& x,
                      ::xml_schema::flags f,
                      ::xml_schema::container* c)
          : ::xml_schema::type (x, f, c),
            destination_ (x.destination_, f, this),
            replyDestination_ (x.replyDestination_, f, this),
            source_ (x.source_, f, this),
            body_ (x.body_, f, this),
            id_ (x.id_, f, this),
            correlationId_ (x.correlationId_, f, this),
            sentTime_ (x.sentTime_, f, this),
            timeToLive_ (x.timeToLive_, f, this),
            correlationTime_ (x.correlationTime_, f, this),
            priority_ (x.priority_, f, this)
          {
          }

          rmsMessage::
          rmsMessage (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f,
                      ::xml_schema::container* c)
          : ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
            destination_ (this),
            replyDestination_ (this),
            source_ (this),
            body_ (this),
            id_ (this),
            correlationId_ (this),
            sentTime_ (this),
            timeToLive_ (this),
            correlationTime_ (this),
            priority_ (this)
          {
            if ((f & ::xml_schema::flags::base) == 0)
            {
              ::xsd::cxx::xml::dom::parser< char > p (e, true, false, true);
              this->parse (p, f);
            }
          }

          void rmsMessage::
          parse (::xsd::cxx::xml::dom::parser< char >& p,
                 ::xml_schema::flags f)
          {
            for (; p.more_content (); p.next_content (false))
            {
              const ::xercesc::DOMElement& i (p.cur_element ());
              const ::xsd::cxx::xml::qualified_name< char > n (
                ::xsd::cxx::xml::dom::name< char > (i));

              // destination
              //
              if (n.name () == "destination" && n.namespace_ ().empty ())
              {
                ::std::auto_ptr< destination_type > r (
                  destination_traits::create (i, f, this));

                if (!destination_.present ())
                {
                  this->destination_.set (r);
                  continue;
                }
              }

              // replyDestination
              //
              if (n.name () == "replyDestination" && n.namespace_ ().empty ())
              {
                ::std::auto_ptr< replyDestination_type > r (
                  replyDestination_traits::create (i, f, this));

                if (!this->replyDestination_)
                {
                  this->replyDestination_.set (r);
                  continue;
                }
              }

              // source
              //
              if (n.name () == "source" && n.namespace_ ().empty ())
              {
                ::std::auto_ptr< source_type > r (
                  source_traits::create (i, f, this));

                if (!this->source_)
                {
                  this->source_.set (r);
                  continue;
                }
              }

              // body
              //
              if (n.name () == "body" && n.namespace_ ().empty ())
              {
                ::std::auto_ptr< body_type > r (
                  body_traits::create (i, f, this));

                if (!this->body_)
                {
                  this->body_.set (r);
                  continue;
                }
              }

              break;
            }

            if (!destination_.present ())
            {
              if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
              {
                std::cerr << "ERROR: expected element (rmsMessage::destination) not found!" << std::endl;
                throw ::xsd::cxx::tree::expected_element< char > (
                  "destination",
                  "");
              }
            }

            while (p.more_attributes ())
            {
              const ::xercesc::DOMAttr& i (p.next_attribute ());
              const ::xsd::cxx::xml::qualified_name< char > n (
                ::xsd::cxx::xml::dom::name< char > (i));

              if (n.name () == "id" && n.namespace_ ().empty ())
              {
                this->id_.set (id_traits::create (i, f, this));
                continue;
              }

              if (n.name () == "correlationId" && n.namespace_ ().empty ())
              {
                this->correlationId_.set (correlationId_traits::create (i, f, this));
                continue;
              }

              if (n.name () == "sentTime" && n.namespace_ ().empty ())
              {
                this->sentTime_.set (sentTime_traits::create (i, f, this));
                continue;
              }

              if (n.name () == "timeToLive" && n.namespace_ ().empty ())
              {
                this->timeToLive_.set (timeToLive_traits::create (i, f, this));
                continue;
              }

              if (n.name () == "correlationTime" && n.namespace_ ().empty ())
              {
                this->correlationTime_.set (correlationTime_traits::create (i, f, this));
                continue;
              }

              if (n.name () == "priority" && n.namespace_ ().empty ())
              {
                this->priority_.set (priority_traits::create (i, f, this));
                continue;
              }
            }

            if (!id_.present ())
            {
              if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
              {
                std::cerr << "ERROR: expected attribute (rmsMessage::id) not found!" << std::endl;
                throw ::xsd::cxx::tree::expected_attribute< char > (
                  "id",
                  "");
              }
            }

            if (!sentTime_.present ())
            {
              if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
              {
                std::cerr << "ERROR: expected attribute (rmsMessage::sentTime) not found!" << std::endl;
                throw ::xsd::cxx::tree::expected_attribute< char > (
                  "sentTime",
                  "");
              }
            }

            if (!timeToLive_.present ())
            {
              if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
              {
                std::cerr << "ERROR: expected attribute (rmsMessage::timeToLive) not found!" << std::endl;
                throw ::xsd::cxx::tree::expected_attribute< char > (
                  "timeToLive",
                  "");
              }
            }
          }

          rmsMessage* rmsMessage::
          _clone (::xml_schema::flags f,
                  ::xml_schema::container* c) const
          {
            return new class rmsMessage (*this, f, c);
          }

          rmsMessage& rmsMessage::
          operator= (const rmsMessage& x)
          {
            if (this != &x)
            {
              static_cast< ::xml_schema::type& > (*this) = x;
              this->destination_ = x.destination_;
              this->replyDestination_ = x.replyDestination_;
              this->source_ = x.source_;
              this->body_ = x.body_;
              this->id_ = x.id_;
              this->correlationId_ = x.correlationId_;
              this->sentTime_ = x.sentTime_;
              this->timeToLive_ = x.timeToLive_;
              this->correlationTime_ = x.correlationTime_;
              this->priority_ = x.priority_;
            }

            return *this;
          }

          rmsMessage::
          ~rmsMessage ()
          {
          }

          ::std::string rmsMessage::
          serialize () const
          {
            // To avoid problems with multi-threaded access to
            // CST XSD ser/deserialization code and underlying
            // Xerces-C++ code, we prevent concurrent access
            // to any serialization code by any class that
            // inherits from XMLSerializable via the use of a
            // static mutex in XMLSerializable.
            boost::mutex::scoped_lock lock(_serializationMutex);

            ::std::ostringstream oss;
            rmsMessage_ (oss, *this);
            return oss.str();
          }

          void rmsMessage::
          deserialize (const ::std::string& serializedData)
          {
            // To avoid problems with multi-threaded access to
            // CST XSD ser/deserialization code and underlying
            // Xerces-C++ code, we prevent concurrent access
            // to any deserialization code by any class that
            // inherits from XMLSerializable via the use of a
            // static mutex in XMLSerializable.
            boost::mutex::scoped_lock lock(_serializationMutex);

            // initialization for XSD
            ::xml_schema::flags flags = ::xml_schema::flags::dont_validate;
            ::xsd::cxx::xml::auto_initializer autoInit
                  ((flags & ::xml_schema::flags::dont_initialize) == 0,
                   (flags & ::xml_schema::flags::keep_dom) == 0);
            ::xsd::cxx::tree::error_handler< char > errorHandler;
            ::xml_schema::properties props;

            // wrap the string in an input stream
            ::std::istringstream iss (serializedData);
            ::xsd::cxx::xml::sax::std_input_source isrc (iss);

            // create a DOM from the input stream
            ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > doc (
                ::xsd::cxx::xml::dom::parse< char > (isrc, errorHandler, props, flags));
            errorHandler.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

            // do the deserialization
            ::xsd::cxx::xml::dom::parser< char > parser (*(doc->getDocumentElement()), true, false, true);
            this->parse (parser, flags);
          }

          ::std::string rmsMessage::
          getClassName () const
          {
            return "gov::fnal::cd::rms::xsd::rmsMessage";
          }

          ::boost::shared_ptr< ::novadaq::XMLSerializable > rmsMessage::
          clone () const
          {
            rmsMessage *copy = this->_clone ();
            boost::shared_ptr<novadaq::XMLSerializable> copyPtr (copy);
            return copyPtr;
          }

          void rmsMessage::
          registerForDeserialization ()
          {
            boost::shared_ptr<novadaq::XMLSerializable> msgPtr;
            novadaq::XMLDeserializationRegistry&
              deserRegistry = novadaq::XMLDeserializationRegistry::getInstance();
            msgPtr.reset(new rmsMessage());
            deserRegistry.registerClass(msgPtr->getClassName(), msgPtr);
          }

          void rmsMessage::
          copyNeededFields (const rmsMessage& x)
          {
            if (x.hasBody()) {
              if (! this->hasBody()) {
                this->setBody(x.getBody());
              }
              else {
                copyTraits<body_type>::copyNeededFields(x.getBody(), this->body());
              }
            }
            if (x.hasDestination()) {
              if (! this->hasDestination()) {
                this->setDestination(x.getDestination());
              }
              else {
                copyTraits<destination_type>::copyNeededFields(x.getDestination(), this->destination());
              }
            }
            if (x.hasId()) {
              if (! this->hasId()) {
                this->setId(x.getId());
              }
              else {
                copyTraits<id_type>::copyNeededFields(x.getId(), this->id());
              }
            }
            if (x.hasReplyDestination()) {
              if (! this->hasReplyDestination()) {
                this->setReplyDestination(x.getReplyDestination());
              }
              else {
                copyTraits<replyDestination_type>::copyNeededFields(x.getReplyDestination(), this->replyDestination());
              }
            }
            if (x.hasSentTime()) {
              if (! this->hasSentTime()) {
                this->setSentTime(x.getSentTime());
              }
              else {
                copyTraits<sentTime_type>::copyNeededFields(x.getSentTime(), this->sentTime());
              }
            }
            if (x.hasSource()) {
              if (! this->hasSource()) {
                this->setSource(x.getSource());
              }
              else {
                copyTraits<source_type>::copyNeededFields(x.getSource(), this->source());
              }
            }
            if (x.hasTimeToLive()) {
              if (! this->hasTimeToLive()) {
                this->setTimeToLive(x.getTimeToLive());
              }
              else {
                copyTraits<timeToLive_type>::copyNeededFields(x.getTimeToLive(), this->timeToLive());
              }
            }
          }
        }
      }
    }
  }
}

#include <istream>
#include <xsd/cxx/xml/sax/std-input-source.hxx>
#include <xsd/cxx/tree/error-handler.hxx>

namespace gov
{
  namespace fnal
  {
    namespace cd
    {
      namespace rms
      {
        namespace xsd
        {
          ::std::auto_ptr< ::gov::fnal::cd::rms::xsd::rmsMessage >
          rmsMessage_ (const ::std::string& u,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
          {
            ::xsd::cxx::xml::auto_initializer i (
              (f & ::xml_schema::flags::dont_initialize) == 0,
              (f & ::xml_schema::flags::keep_dom) == 0);

            ::xsd::cxx::tree::error_handler< char > h;

            ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
              ::xsd::cxx::xml::dom::parse< char > (
                u, h, p, f));

            h.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

            return ::std::auto_ptr< ::gov::fnal::cd::rms::xsd::rmsMessage > (
              ::gov::fnal::cd::rms::xsd::rmsMessage_ (
                d, f | ::xml_schema::flags::own_dom, p));
          }

          ::std::auto_ptr< ::gov::fnal::cd::rms::xsd::rmsMessage >
          rmsMessage_ (const ::std::string& u,
                       ::xml_schema::error_handler& h,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
          {
            ::xsd::cxx::xml::auto_initializer i (
              (f & ::xml_schema::flags::dont_initialize) == 0,
              (f & ::xml_schema::flags::keep_dom) == 0);

            ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
              ::xsd::cxx::xml::dom::parse< char > (
                u, h, p, f));

            if (!d.get ())
              throw ::xsd::cxx::tree::parsing< char > ();

            return ::std::auto_ptr< ::gov::fnal::cd::rms::xsd::rmsMessage > (
              ::gov::fnal::cd::rms::xsd::rmsMessage_ (
                d, f | ::xml_schema::flags::own_dom, p));
          }

          ::std::auto_ptr< ::gov::fnal::cd::rms::xsd::rmsMessage >
          rmsMessage_ (const ::std::string& u,
                       ::xercesc::DOMErrorHandler& h,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
          {
            ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
              ::xsd::cxx::xml::dom::parse< char > (
                u, h, p, f));

            if (!d.get ())
              throw ::xsd::cxx::tree::parsing< char > ();

            return ::std::auto_ptr< ::gov::fnal::cd::rms::xsd::rmsMessage > (
              ::gov::fnal::cd::rms::xsd::rmsMessage_ (
                d, f | ::xml_schema::flags::own_dom, p));
          }

          ::std::auto_ptr< ::gov::fnal::cd::rms::xsd::rmsMessage >
          rmsMessage_ (::std::istream& is,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
          {
            ::xsd::cxx::xml::auto_initializer i (
              (f & ::xml_schema::flags::dont_initialize) == 0,
              (f & ::xml_schema::flags::keep_dom) == 0);

            ::xsd::cxx::xml::sax::std_input_source isrc (is);
            return ::gov::fnal::cd::rms::xsd::rmsMessage_ (isrc, f, p);
          }

          ::std::auto_ptr< ::gov::fnal::cd::rms::xsd::rmsMessage >
          rmsMessage_ (::std::istream& is,
                       ::xml_schema::error_handler& h,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
          {
            ::xsd::cxx::xml::auto_initializer i (
              (f & ::xml_schema::flags::dont_initialize) == 0,
              (f & ::xml_schema::flags::keep_dom) == 0);

            ::xsd::cxx::xml::sax::std_input_source isrc (is);
            return ::gov::fnal::cd::rms::xsd::rmsMessage_ (isrc, h, f, p);
          }

          ::std::auto_ptr< ::gov::fnal::cd::rms::xsd::rmsMessage >
          rmsMessage_ (::std::istream& is,
                       ::xercesc::DOMErrorHandler& h,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
          {
            ::xsd::cxx::xml::sax::std_input_source isrc (is);
            return ::gov::fnal::cd::rms::xsd::rmsMessage_ (isrc, h, f, p);
          }

          ::std::auto_ptr< ::gov::fnal::cd::rms::xsd::rmsMessage >
          rmsMessage_ (::std::istream& is,
                       const ::std::string& sid,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
          {
            ::xsd::cxx::xml::auto_initializer i (
              (f & ::xml_schema::flags::dont_initialize) == 0,
              (f & ::xml_schema::flags::keep_dom) == 0);

            ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
            return ::gov::fnal::cd::rms::xsd::rmsMessage_ (isrc, f, p);
          }

          ::std::auto_ptr< ::gov::fnal::cd::rms::xsd::rmsMessage >
          rmsMessage_ (::std::istream& is,
                       const ::std::string& sid,
                       ::xml_schema::error_handler& h,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
          {
            ::xsd::cxx::xml::auto_initializer i (
              (f & ::xml_schema::flags::dont_initialize) == 0,
              (f & ::xml_schema::flags::keep_dom) == 0);

            ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
            return ::gov::fnal::cd::rms::xsd::rmsMessage_ (isrc, h, f, p);
          }

          ::std::auto_ptr< ::gov::fnal::cd::rms::xsd::rmsMessage >
          rmsMessage_ (::std::istream& is,
                       const ::std::string& sid,
                       ::xercesc::DOMErrorHandler& h,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
          {
            ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
            return ::gov::fnal::cd::rms::xsd::rmsMessage_ (isrc, h, f, p);
          }

          ::std::auto_ptr< ::gov::fnal::cd::rms::xsd::rmsMessage >
          rmsMessage_ (::xercesc::InputSource& i,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
          {
            ::xsd::cxx::tree::error_handler< char > h;

            ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
              ::xsd::cxx::xml::dom::parse< char > (
                i, h, p, f));

            h.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

            return ::std::auto_ptr< ::gov::fnal::cd::rms::xsd::rmsMessage > (
              ::gov::fnal::cd::rms::xsd::rmsMessage_ (
                d, f | ::xml_schema::flags::own_dom, p));
          }

          ::std::auto_ptr< ::gov::fnal::cd::rms::xsd::rmsMessage >
          rmsMessage_ (::xercesc::InputSource& i,
                       ::xml_schema::error_handler& h,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
          {
            ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
              ::xsd::cxx::xml::dom::parse< char > (
                i, h, p, f));

            if (!d.get ())
              throw ::xsd::cxx::tree::parsing< char > ();

            return ::std::auto_ptr< ::gov::fnal::cd::rms::xsd::rmsMessage > (
              ::gov::fnal::cd::rms::xsd::rmsMessage_ (
                d, f | ::xml_schema::flags::own_dom, p));
          }

          ::std::auto_ptr< ::gov::fnal::cd::rms::xsd::rmsMessage >
          rmsMessage_ (::xercesc::InputSource& i,
                       ::xercesc::DOMErrorHandler& h,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
          {
            ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
              ::xsd::cxx::xml::dom::parse< char > (
                i, h, p, f));

            if (!d.get ())
              throw ::xsd::cxx::tree::parsing< char > ();

            return ::std::auto_ptr< ::gov::fnal::cd::rms::xsd::rmsMessage > (
              ::gov::fnal::cd::rms::xsd::rmsMessage_ (
                d, f | ::xml_schema::flags::own_dom, p));
          }

          ::std::auto_ptr< ::gov::fnal::cd::rms::xsd::rmsMessage >
          rmsMessage_ (const ::xercesc::DOMDocument& doc,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
          {
            if (f & ::xml_schema::flags::keep_dom)
            {
              ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
                static_cast< ::xercesc::DOMDocument* > (doc.cloneNode (true)));

              return ::std::auto_ptr< ::gov::fnal::cd::rms::xsd::rmsMessage > (
                ::gov::fnal::cd::rms::xsd::rmsMessage_ (
                  d, f | ::xml_schema::flags::own_dom, p));
            }

            const ::xercesc::DOMElement& e (*doc.getDocumentElement ());
            const ::xsd::cxx::xml::qualified_name< char > n (
              ::xsd::cxx::xml::dom::name< char > (e));

            if (n.name () == "rmsMessage" &&
                n.namespace_ () == "")
            {
              ::std::auto_ptr< ::gov::fnal::cd::rms::xsd::rmsMessage > r (
                ::xsd::cxx::tree::traits< ::gov::fnal::cd::rms::xsd::rmsMessage, char >::create (
                  e, f, 0));
              return r;
            }

            throw ::xsd::cxx::tree::unexpected_element < char > (
              n.name (),
              n.namespace_ (),
              "rmsMessage",
              "");
          }

          ::std::auto_ptr< ::gov::fnal::cd::rms::xsd::rmsMessage >
          rmsMessage_ (::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties&)
          {
            ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > c (
              ((f & ::xml_schema::flags::keep_dom) &&
               !(f & ::xml_schema::flags::own_dom))
              ? static_cast< ::xercesc::DOMDocument* > (d->cloneNode (true))
              : 0);

            ::xercesc::DOMDocument& doc (c.get () ? *c : *d);
            const ::xercesc::DOMElement& e (*doc.getDocumentElement ());

            const ::xsd::cxx::xml::qualified_name< char > n (
              ::xsd::cxx::xml::dom::name< char > (e));

            if (f & ::xml_schema::flags::keep_dom)
              doc.setUserData (::xml_schema::dom::tree_node_key,
                               (c.get () ? &c : &d),
                               0);

            if (n.name () == "rmsMessage" &&
                n.namespace_ () == "")
            {
              ::std::auto_ptr< ::gov::fnal::cd::rms::xsd::rmsMessage > r (
                ::xsd::cxx::tree::traits< ::gov::fnal::cd::rms::xsd::rmsMessage, char >::create (
                  e, f, 0));
              return r;
            }

            throw ::xsd::cxx::tree::unexpected_element < char > (
              n.name (),
              n.namespace_ (),
              "rmsMessage",
              "");
          }
        }
      }
    }
  }
}

#include <ostream>
#include <xsd/cxx/tree/error-handler.hxx>
#include <xsd/cxx/xml/dom/serialization-source.hxx>

namespace gov
{
  namespace fnal
  {
    namespace cd
    {
      namespace rms
      {
        namespace xsd
        {
          void
          rmsMessage_ (::std::ostream& o,
                       const ::gov::fnal::cd::rms::xsd::rmsMessage& s,
                       const ::xml_schema::namespace_infomap& m,
                       const ::std::string& e,
                       ::xml_schema::flags f)
          {
            ::xsd::cxx::xml::auto_initializer i (
              (f & ::xml_schema::flags::dont_initialize) == 0);

            ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
              ::gov::fnal::cd::rms::xsd::rmsMessage_ (s, m, f));

            ::xsd::cxx::tree::error_handler< char > h;

            ::xsd::cxx::xml::dom::ostream_format_target t (o);
            if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
            {
              h.throw_if_failed< ::xsd::cxx::tree::serialization< char > > ();
            }
          }

          void
          rmsMessage_ (::std::ostream& o,
                       const ::gov::fnal::cd::rms::xsd::rmsMessage& s,
                       ::xml_schema::error_handler& h,
                       const ::xml_schema::namespace_infomap& m,
                       const ::std::string& e,
                       ::xml_schema::flags f)
          {
            ::xsd::cxx::xml::auto_initializer i (
              (f & ::xml_schema::flags::dont_initialize) == 0);

            ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
              ::gov::fnal::cd::rms::xsd::rmsMessage_ (s, m, f));
            ::xsd::cxx::xml::dom::ostream_format_target t (o);
            if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
            {
              throw ::xsd::cxx::tree::serialization< char > ();
            }
          }

          void
          rmsMessage_ (::std::ostream& o,
                       const ::gov::fnal::cd::rms::xsd::rmsMessage& s,
                       ::xercesc::DOMErrorHandler& h,
                       const ::xml_schema::namespace_infomap& m,
                       const ::std::string& e,
                       ::xml_schema::flags f)
          {
            ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
              ::gov::fnal::cd::rms::xsd::rmsMessage_ (s, m, f));
            ::xsd::cxx::xml::dom::ostream_format_target t (o);
            if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
            {
              throw ::xsd::cxx::tree::serialization< char > ();
            }
          }

          void
          rmsMessage_ (::xercesc::XMLFormatTarget& t,
                       const ::gov::fnal::cd::rms::xsd::rmsMessage& s,
                       const ::xml_schema::namespace_infomap& m,
                       const ::std::string& e,
                       ::xml_schema::flags f)
          {
            ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
              ::gov::fnal::cd::rms::xsd::rmsMessage_ (s, m, f));

            ::xsd::cxx::tree::error_handler< char > h;

            if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
            {
              h.throw_if_failed< ::xsd::cxx::tree::serialization< char > > ();
            }
          }

          void
          rmsMessage_ (::xercesc::XMLFormatTarget& t,
                       const ::gov::fnal::cd::rms::xsd::rmsMessage& s,
                       ::xml_schema::error_handler& h,
                       const ::xml_schema::namespace_infomap& m,
                       const ::std::string& e,
                       ::xml_schema::flags f)
          {
            ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
              ::gov::fnal::cd::rms::xsd::rmsMessage_ (s, m, f));
            if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
            {
              throw ::xsd::cxx::tree::serialization< char > ();
            }
          }

          void
          rmsMessage_ (::xercesc::XMLFormatTarget& t,
                       const ::gov::fnal::cd::rms::xsd::rmsMessage& s,
                       ::xercesc::DOMErrorHandler& h,
                       const ::xml_schema::namespace_infomap& m,
                       const ::std::string& e,
                       ::xml_schema::flags f)
          {
            ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
              ::gov::fnal::cd::rms::xsd::rmsMessage_ (s, m, f));
            if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
            {
              throw ::xsd::cxx::tree::serialization< char > ();
            }
          }

          void
          rmsMessage_ (::xercesc::DOMDocument& d,
                       const ::gov::fnal::cd::rms::xsd::rmsMessage& s,
                       ::xml_schema::flags)
          {
            ::xercesc::DOMElement& e (*d.getDocumentElement ());
            const ::xsd::cxx::xml::qualified_name< char > n (
              ::xsd::cxx::xml::dom::name< char > (e));

            if (n.name () == "rmsMessage" &&
                n.namespace_ () == "")
            {
              e << s;
            }
            else
            {
              throw ::xsd::cxx::tree::unexpected_element < char > (
                n.name (),
                n.namespace_ (),
                "rmsMessage",
                "");
            }
          }

          ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument >
          rmsMessage_ (const ::gov::fnal::cd::rms::xsd::rmsMessage& s,
                       const ::xml_schema::namespace_infomap& m,
                       ::xml_schema::flags f)
          {
            ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
              ::xsd::cxx::xml::dom::serialize< char > (
                "rmsMessage",
                "",
                m, f));

            ::gov::fnal::cd::rms::xsd::rmsMessage_ (*d, s, f);
            return d;
          }

          void
          operator<< (::xercesc::DOMElement& e, const messageBody& i)
          {
            e << static_cast< const ::xml_schema::type& > (i);

            // content
            //
            {
              ::xercesc::DOMElement& s (
                ::xsd::cxx::xml::dom::create_element (
                  "content",
                  e));

              if (! i.hasContent ()) {
                std::cerr << "WARNING: attempting to serialize a messageBody with an empty content field!" << std::endl;
              }
              s << i.content ();
            }

            // className
            //
            {
              ::xercesc::DOMAttr& a (
                ::xsd::cxx::xml::dom::create_attribute (
                  "className",
                  e));

              if (! i.hasClassName ()) {
                std::cerr << "WARNING: attempting to serialize a messageBody with an empty className field!" << std::endl;
              }
              a << i.className ();
            }
          }

          void
          operator<< (::xercesc::DOMElement& e, const messageSource& i)
          {
            e << static_cast< const ::xml_schema::type& > (i);

            // hostName
            //
            {
              ::xercesc::DOMAttr& a (
                ::xsd::cxx::xml::dom::create_attribute (
                  "hostName",
                  e));

              if (! i.hasHostName ()) {
                std::cerr << "WARNING: attempting to serialize a messageSource with an empty hostName field!" << std::endl;
              }
              a << i.hostName ();
            }

            // applicationName
            //
            {
              ::xercesc::DOMAttr& a (
                ::xsd::cxx::xml::dom::create_attribute (
                  "applicationName",
                  e));

              if (! i.hasApplicationName ()) {
                std::cerr << "WARNING: attempting to serialize a messageSource with an empty applicationName field!" << std::endl;
              }
              a << i.applicationName ();
            }
          }

          void
          operator<< (::xercesc::DOMElement& e, const destination& i)
          {
            e << static_cast< const ::xml_schema::type& > (i);

            // property
            //
            for (destination::property_const_iterator
                 b (i.property ().begin ()), n (i.property ().end ());
                 b != n; ++b)
            {
              ::xercesc::DOMElement& s (
                ::xsd::cxx::xml::dom::create_element (
                  "property",
                  e));

              s << *b;
            }
          }

          void
          operator<< (::xercesc::DOMElement& e, const property& i)
          {
            e << static_cast< const ::xml_schema::type& > (i);

            // value
            //
            {
              ::xercesc::DOMElement& s (
                ::xsd::cxx::xml::dom::create_element (
                  "value",
                  e));

              if (! i.hasValue ()) {
                std::cerr << "WARNING: attempting to serialize a property with an empty value field!" << std::endl;
              }
              s << i.value ();
            }

            // name
            //
            {
              ::xercesc::DOMAttr& a (
                ::xsd::cxx::xml::dom::create_attribute (
                  "name",
                  e));

              if (! i.hasName ()) {
                std::cerr << "WARNING: attempting to serialize a property with an empty name field!" << std::endl;
              }
              a << i.name ();
            }
          }

          void
          operator<< (::xercesc::DOMElement& e, const rmsMessage& i)
          {
            e << static_cast< const ::xml_schema::type& > (i);

            // destination
            //
            {
              ::xercesc::DOMElement& s (
                ::xsd::cxx::xml::dom::create_element (
                  "destination",
                  e));

              if (! i.hasDestination ()) {
                std::cerr << "WARNING: attempting to serialize a rmsMessage with an empty destination field!" << std::endl;
              }
              s << i.destination ();
            }

            // replyDestination
            //
            if (i.replyDestination ())
            {
              ::xercesc::DOMElement& s (
                ::xsd::cxx::xml::dom::create_element (
                  "replyDestination",
                  e));

              s << *i.replyDestination ();
            }

            // source
            //
            if (i.source ())
            {
              ::xercesc::DOMElement& s (
                ::xsd::cxx::xml::dom::create_element (
                  "source",
                  e));

              s << *i.source ();
            }

            // body
            //
            if (i.body ())
            {
              ::xercesc::DOMElement& s (
                ::xsd::cxx::xml::dom::create_element (
                  "body",
                  e));

              s << *i.body ();
            }

            // id
            //
            {
              ::xercesc::DOMAttr& a (
                ::xsd::cxx::xml::dom::create_attribute (
                  "id",
                  e));

              if (! i.hasId ()) {
                std::cerr << "WARNING: attempting to serialize a rmsMessage with an empty id field!" << std::endl;
              }
              a << i.id ();
            }

            // correlationId
            //
            if (i.correlationId ())
            {
              ::xercesc::DOMAttr& a (
                ::xsd::cxx::xml::dom::create_attribute (
                  "correlationId",
                  e));

              a << *i.correlationId ();
            }

            // sentTime
            //
            {
              ::xercesc::DOMAttr& a (
                ::xsd::cxx::xml::dom::create_attribute (
                  "sentTime",
                  e));

              if (! i.hasSentTime ()) {
                std::cerr << "WARNING: attempting to serialize a rmsMessage with an empty sentTime field!" << std::endl;
              }
              a << i.sentTime ();
            }

            // timeToLive
            //
            {
              ::xercesc::DOMAttr& a (
                ::xsd::cxx::xml::dom::create_attribute (
                  "timeToLive",
                  e));

              if (! i.hasTimeToLive ()) {
                std::cerr << "WARNING: attempting to serialize a rmsMessage with an empty timeToLive field!" << std::endl;
              }
              a << i.timeToLive ();
            }

            // correlationTime
            //
            if (i.correlationTime ())
            {
              ::xercesc::DOMAttr& a (
                ::xsd::cxx::xml::dom::create_attribute (
                  "correlationTime",
                  e));

              a << *i.correlationTime ();
            }

            // priority
            //
            if (i.priority ())
            {
              ::xercesc::DOMAttr& a (
                ::xsd::cxx::xml::dom::create_attribute (
                  "priority",
                  e));

              a << *i.priority ();
            }
          }
        }
      }
    }
  }
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

